package com.mtm.tms.action.task;

package ..deTemp.1747117363407;

import com.alibaba.fastjson.JSON;
import com.mtm.tms.action.scxs.ContractAction;
import com.mtm.tms.domain.HibernatePage;
import com.mtm.tms.domain.HibernatePageHelper;
import com.mtm.tms.domain.HibernateUtil;
import com.mtm.tms.form.task.TaskForm;
import com.mtm.tms.form.xtgl.UserForm;
import com.mtm.tms.po.cw.Bxd;
import com.mtm.tms.po.scxs.Contract;
import com.mtm.tms.po.scxs.Scxm;
import com.mtm.tms.po.scxs.ScxmJoin;
import com.mtm.tms.po.scxs.ScxmPj;
import com.mtm.tms.po.scxs.ScxmQdzx;
import com.mtm.tms.po.scxs.ScxmSh;
import com.mtm.tms.po.scxs.ScxmSq;
import com.mtm.tms.po.scxs.ScxmYw;
import com.mtm.tms.po.task.SjhzVO;
import com.mtm.tms.po.xtgl.Dept;
import com.mtm.tms.po.xtgl.Org;
import com.mtm.tms.po.xtgl.User;
import com.mtm.tms.po.xtgl.WorkFlowInfo;
import com.mtm.tms.po.xtgl.WorkFlowStepInfo;
import com.mtm.tms.po.xtgl.WorkFlowTache;
import com.mtm.tms.util.DateUtil;
import com.mtm.tms.util.StringUtils;
import com.mtm.tms.util.WorkFlowUitl;
import com.mtm.tms.vo.ScxmJoinVo;
import com.mtm.tms.vo.SjhzTotalVO;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.Formatter;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.Region;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;
import org.apache.struts.upload.FormFile;
import org.apache.struts.upload.MultipartRequestHandler;
import org.hibernate.Query;
import org.hibernate.Session;

public class ScxsAction extends DispatchAction {
  public ActionForward queryIndex(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    try {
      Session s = HibernateUtil.currentSession();
      String org_sql = "SELECT org FROM Org org WHERE org.isDeleted='0' AND org.lx in('1','2','3','4') ORDER BY org.id,org.orgName";
      Query org_query = s.createQuery(org_sql);
      List orgList = org_query.list();
      Query queryUser = s.createQuery(" FROM User user WHERE user.isDeleted='0' and user.deptID=:deptID ");
      queryUser.setParameter("deptID", Long.valueOf(userForm.getDeptID()));
      List listUser = queryUser.list();
      List listDept = s.createQuery(" FROM Dept dept WHERE dept.isDeleted='0' ORDER BY dept.sortID ").list();
      request.setAttribute("listDept", listDept);
      request.setAttribute("listUser", listUser);
      request.setAttribute("orgList", orgList);
      request.getSession().setAttribute("urlFrom", "queryIndex");
      return mapping.findForward("queryIndex");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } 
  }
  
  public static Map<String, Object> computeData(String id, Session session, String excludeId, HttpServletRequest request) throws IllegalAccessException, InvocationTargetException {
    Scxm scxm = (Scxm)session.get(Scxm.class, id);
    Map<String, Object> map = new HashMap<String, Object>();
    map.put("ratio", "2");
    map.put("scxm", scxm);
    BigDecimal bigDecimal = new BigDecimal(scxm.getYsje());
    map.put("sumBxje", bigDecimal);
    Query createQuery = session.createQuery("FROM Bxd b where b.isDeleted='0' and (b.currentTacheId='2c9081077a4213ad017a421a381d0008' or b.currentTacheId='2c9081077a64c278017a64cabb9e000b' or b.currentTacheId='828081817aa9380e017aa940e7ba0009') and b.scxmId=:scxmId ");
    List<Bxd> list = createQuery.setParameter("scxmId", id).list();
    BigDecimal yBxje = new BigDecimal("0.00");
    for (int i = 0; i < list.size(); i++) {
      Bxd bxd = list.get(i);
      yBxje = yBxje.add(new BigDecimal(bxd.getJexx().replace(",", "")));
    } 
    map.put("yBxje", yBxje);
    String bxingJeHql = "FROM Bxd b where b.isDeleted='0' and ((b.createOrgId='1' and b.currentTacheId!='2c9081077a4213ad017a421a381d0008' and b.currentTacheId!='2c9081077a420131017a4206b2fc0001') or (b.createOrgId='320' and b.currentTacheId!='2c9081077a64c278017a64cabb9e000b' and b.currentTacheId!='2c9081077a64c278017a64c80f850003') or (b.createOrgId='360' and b.currentTacheId!='828081817aa9380e017aa940e7ba0009' and b.currentTacheId!='828081817aa9380e017aa93e98010002')) and b.scxmId=:scxmId ";
    Query createQuery1 = session.createQuery(bxingJeHql);
    List<Bxd> list1 = createQuery1.setParameter("scxmId", id).list();
    BigDecimal bxingJe = new BigDecimal("0.00");
    Bxd currentBxd = (Bxd)session.get(Bxd.class, excludeId);
    currentBxd = (currentBxd == null) ? new Bxd() : currentBxd;
    for (int j = 0; j < list1.size(); j++) {
      Bxd bxd = list1.get(j);
      if (!bxd.getId().equals(excludeId)) {
        BigDecimal bigDecimal2 = new BigDecimal(bxd.getJexx().replace(",", ""));
        bxingJe = bxingJe.add(bigDecimal2);
      } 
    } 
    map.put("bxingJe", bxingJe);
    if (currentBxd == null || currentBxd.getJexx() == null)
      currentBxd.setJexx("0.00"); 
    map.put("currentBxd", currentBxd);
    BigDecimal sumYBxJe = yBxje.add(bxingJe);
    map.put("sumYBxJe", sumYBxJe);
    BigDecimal multiply = bigDecimal.multiply(new BigDecimal("0.02")).multiply(new BigDecimal("10000"));
    map.put("kBxJe", multiply.setScale(2, 4));
    String yBxRatio = (new Formatter()).format("%.2f", new Object[] { Double.valueOf(yBxje.doubleValue() / multiply.doubleValue() * 100.0D) }).toString();
    map.put("yBxRatio", yBxRatio);
    String bxingRatio = (new Formatter()).format("%.2f", new Object[] { Double.valueOf(bxingJe.doubleValue() / multiply.doubleValue() * 100.0D) }).toString();
    map.put("bxingRatio", bxingRatio);
    Double sumBxRatio = Double.valueOf(Double.parseDouble(yBxRatio.replaceAll(",", "")) + 
        Double.parseDouble(bxingRatio.replaceAll(",", "")));
    map.put("sumBxRatio", sumBxRatio);
    Map<String, BigDecimal> computeDeptBxJe = ContractAction.computeDeptBxJe(session, excludeId, scxm
        .getCjrDeptID());
    map.put("deptName", scxm.getCjrDeptName());
    map.put("sumDeptMoney", computeDeptBxJe.get("sumDeptMoney"));
    map.put("ybxDeptMoney", computeDeptBxJe.get("ybxDeptMoney"));
    map.put("bxingDeptMoney", computeDeptBxJe.get("bxingDeptMoney"));
    return map;
  }
  
  public ActionForward computeByScxmId(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      String excludeId = request.getParameter("excludeId");
      excludeId = StringUtils.isEmpty(excludeId) ? "" : excludeId;
      Session session = HibernateUtil.currentSession();
      Map<String, Object> map = computeData(id, session, excludeId, request);
      String jsonString = JSON.toJSONString(map);
      response.setContentType("text/html; charset=UTF-8");
      response.getWriter().print(jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  public ActionForward add(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    try {
      Session s = HibernateUtil.currentSession();
      request.setAttribute("message", request.getParameter("message"));
      List listSbwx = s.createQuery("SELECT distinct user FROM User user ,UserRole userRole,Role role WHERE user.isDeleted='0' AND user.id=userRole.userID AND userRole.roleID=role.id   AND role.roleCode='sbwx' ").list();
      int serNo = 1;
      SimpleDateFormat simple = new SimpleDateFormat("yyyy-MM-dd");
      Date date = new Date();
      String year = simple.format(date).substring(0, 4);
      Query query = s.createQuery("FROM Scxm t WHERE t.businessOpportunityCode LIKE :businessOpportunityCode ORDER BY t.businessOpportunityCode DESC");
      if (userForm.getOrgID() == 320L) {
        query.setParameter("businessOpportunityCode", "MTM-JK-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 361L) {
        query.setParameter("businessOpportunityCode", "MTM-XX-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 360L) {
        query.setParameter("businessOpportunityCode", "MTM-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 1L) {
        query.setParameter("businessOpportunityCode", "MTM-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 180L) {
        query.setParameter("businessOpportunityCode", "MTM-SD-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 300L) {
        query.setParameter("businessOpportunityCode", "MTM-SW-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 200L) {
        query.setParameter("businessOpportunityCode", "MTM-HN-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 240L) {
        query.setParameter("businessOpportunityCode", "MTM-SZ-SJ-" + year + "-%");
      } else if (userForm.getOrgID() == 220L) {
        query.setParameter("businessOpportunityCode", "MTM-XA-SJ-" + year + "-%");
      } else {
        query.setParameter("businessOpportunityCode", "MTM-SJ-" + year + "-%");
      } 
      List<Scxm> todayScxmList = query.list();
      if (todayScxmList != null && todayScxmList.size() > 0) {
        Scxm scxm = todayScxmList.get(0);
        String serNoStr = scxm.getBusinessOpportunityCode().substring(scxm.getBusinessOpportunityCode().length() - 4);
        serNo = Integer.parseInt(serNoStr);
        serNo++;
      } 
      String businessOpportunityCode = "";
      if (userForm.getOrgID() == 320L) {
        businessOpportunityCode = "MTM-JK-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 360L) {
        businessOpportunityCode = "MTM-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 361L) {
        businessOpportunityCode = "MTM-XX-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 1L) {
        businessOpportunityCode = "MTM-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 180L) {
        businessOpportunityCode = "MTM-SD-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 300L) {
        businessOpportunityCode = "MTM-SW-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 200L) {
        businessOpportunityCode = "MTM-HN-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 240L) {
        businessOpportunityCode = "MTM-SZ-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else if (userForm.getOrgID() == 220L) {
        businessOpportunityCode = "MTM-XA-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } else {
        businessOpportunityCode = "MTM-SJ-" + year + "-" + String.format("%04d", new Object[] { Integer.valueOf(serNo) });
      } 
      List regList = s.createQuery("SELECT reg FROM Region reg WHERE reg.regionLevel='2' and reg.isDelete='0' order by  reg.regionCode ").list();
      request.setAttribute("regList", regList);
      Query queryUser = s.createQuery(" FROM User user WHERE user.isDeleted='0' and user.deptID=:deptID ");
      queryUser.setParameter("deptID", Long.valueOf(userForm.getDeptID()));
      List listUser = queryUser.list();
      List disOrgList = s.createQuery("SELECT d FROM DistributionOrg d WHERE d.isDeleted='0' ORDER BY d.name ").list();
      request.setAttribute("disOrgList", disOrgList);
      List listDept = s.createQuery(" FROM Dept dept WHERE dept.isDeleted='0' ORDER BY dept.sortID ").list();
      String org_sql = "SELECT org FROM Org org WHERE org.isDeleted='0' AND org.lx in('1','2','3','4') ORDER BY org.id,org.orgName";
      Query org_query = s.createQuery(org_sql);
      List orgList = org_query.list();
      String query_workFlow_sql = "SELECT work FROM WorkFlowInfo work  where work.workFlowCode=:workFlowCode AND work.isDeleted = '0' AND work.orgId=:orgId";
      Query scxsQuery = s.createQuery(query_workFlow_sql);
      String workFlowCode = WorkFlowUitl.getWorkFlowCode("ScxmApplication", Long.valueOf(userForm.getOrgID()).toString(), "1");
      scxsQuery.setString("workFlowCode", workFlowCode);
      scxsQuery.setString("orgId", Long.valueOf(userForm.getOrgID()).toString());
      WorkFlowInfo work = (WorkFlowInfo)scxsQuery.uniqueResult();
      List<WorkFlowTache> tacheList = null;
      if (work != null) {
        String query_tache_sql = "select tache from WorkFlowTache tache where tache.workFlowId=:workFlowId AND tache.isDeleted='0' order by tache.sortId";
        Query tache_query = s.createQuery(query_tache_sql);
        tache_query.setString("workFlowId", work.getId());
        tacheList = tache_query.list();
      } 
      WorkFlowTache currentTache = null;
      if (tacheList != null && tacheList.size() > 0)
        currentTache = tacheList.get(0); 
      WorkFlowStepInfo stepInfo = WorkFlowUitl.getWorkFlowStepByStep(userForm, currentTache, "", s);
      request.setAttribute("listLead", stepInfo.getUserList());
      request.setAttribute("currentTache", currentTache);
      request.setAttribute("nextTache", stepInfo.getWorkFlowTache());
      request.setAttribute("orgList", orgList);
      request.setAttribute("listDept", listDept);
      request.setAttribute("listUser", listUser);
      request.setAttribute("businessOpportunityCode", businessOpportunityCode);
      request.setAttribute("listSbwx", listSbwx);
      return mapping.findForward("add");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward save(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      TaskForm taskForm = (TaskForm)form;
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String xmmc = request.getParameter("xmmc");
      String xmlx = request.getParameter("xmlx");
      String xmjd = request.getParameter("xmjd");
      String zyx = request.getParameter("zyx");
      String bwd = request.getParameter("bwd");
      String ysje = request.getParameter("ysje");
      String ssqy = request.getParameter("ssqy");
      String jsdw = request.getParameter("jsdw");
      String lxr = request.getParameter("lxr");
      String lxdh = request.getParameter("lxdh");
      String bz = request.getParameter("bz");
      String createTime = request.getParameter("createTime");
      String type = request.getParameter("type");
      String businessOpportunityCode = request.getParameter("businessOpportunityCode");
      String businessType = request.getParameter("businessType");
      String fundSource = request.getParameter("fundSource");
      String isGreat = request.getParameter("isGreat");
      String wholeBudget = request.getParameter("wholeBudget");
      String businessOpportunityType = request.getParameter("businessOpportunityType");
      String provinceCode = request.getParameter("provinceCode");
      String provinceName = request.getParameter("provinceName");
      String cityCode = request.getParameter("cityCode");
      String cityName = request.getParameter("cityName");
      String districtCode = request.getParameter("districtCode");
      String districtName = request.getParameter("districtName");
      String salesDeptId = request.getParameter("deptID");
      String salesDeptName = request.getParameter("deptName");
      String salesPersonId = request.getParameter("userID").trim();
      String salesPersonName = request.getParameter("userName").trim();
      String preSalesPersonDeptName = request.getParameter("preDeptName").trim();
      String preSalesPersonDeptId = request.getParameter("preDeptID").trim();
      String preSalesPersonId = request.getParameter("preUserID").trim();
      String preSalesPersonName = request.getParameter("preUserName").trim();
      String hasAgent = request.getParameter("hasAgent");
      String agentId = request.getParameter("agentId");
      String agentName = request.getParameter("agentName");
      String projectRate = request.getParameter("projectRate");
      String planSignDate = request.getParameter("planSignDate");
      String projectContent = request.getParameter("projectContent");
      String competitorAnalysis = request.getParameter("competitorAnalysis");
      String projectEstablishmentDate = request.getParameter("projectEstablishmentDate");
      String shrID = request.getParameter("shrID");
      String nextTacheId = request.getParameter("nextTacheId");
      String nextTacheName = request.getParameter("nextTacheName");
      String businessStage = request.getParameter("businessStage");
      Scxm scxm = new Scxm();
      MultipartRequestHandler mrh = taskForm.getMultipartRequestHandler();
      Hashtable elements = mrh.getFileElements();
      Collection values = elements.values();
      for (Iterator<FormFile> i = values.iterator(); i.hasNext(); ) {
        FormFile file = i.next();
        String fileName = file.getFileName();
        String dir = this.servlet.getServletContext().getRealPath("/file");
        if (file != null && fileName.length() > 4) {
          scxm.setFileName(fileName);
          dir = dir + "/";
          InputStream streamIn = file.getInputStream();
          Random randoms = new Random();
          int intrandom = randoms.nextInt();
          OutputStream streamOut = new FileOutputStream(dir + intrandom + fileName);
          scxm.setSaveName(intrandom + fileName);
          int bytesRead = 0;
          byte[] buffer = new byte[8192];
          while ((bytesRead = streamIn.read(buffer, 0, 8192)) != -1)
            streamOut.write(buffer, 0, bytesRead); 
          streamOut.close();
          streamIn.close();
          file.destroy();
        } 
      } 
      scxm.setShirId(shrID);
      scxm.setCurrentTacheId(nextTacheId);
      scxm.setCurrentTacheName(nextTacheName);
      scxm.setXmmc(xmmc);
      scxm.setXmlx(xmlx);
      scxm.setXmjd(xmjd);
      scxm.setZyx(zyx);
      scxm.setBwd(bwd);
      scxm.setYsje(ysje);
      scxm.setJsdw(jsdw);
      scxm.setSsqy(ssqy);
      scxm.setLxdh(lxdh);
      scxm.setLxr(lxr);
      scxm.setBz(bz);
      if (createTime != null) {
        scxm.setCreateTime(createTime + StringUtils.getDateTime().substring(10, 19));
      } else {
        scxm.setCreateTime(StringUtils.getDateTime());
      } 
      scxm.setType(type);
      if (userForm.getOrgID() == 320L || userForm.getOrgID() == 361L || userForm.getOrgID() == 360L || userForm.getOrgID() == 1L) {
        scxm.setState("1");
      } else {
        scxm.setState("2");
      } 
      if (userForm.getId() == 141L)
        scxm.setState("2"); 
      scxm.setCjrID(userForm.getId() + "");
      scxm.setCjr(userForm.getUserName());
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCreateOrgId(userForm.getOrgID());
      scxm.setCreateOrgName(userForm.getOrgName());
      scxm.setBusinessOpportunityCode(businessOpportunityCode);
      scxm.setBusinessType(businessType);
      scxm.setFundSource(fundSource);
      scxm.setIsGreat(isGreat);
      scxm.setWholeBudget(wholeBudget);
      scxm.setBusinessOpportunityType(businessOpportunityType);
      scxm.setSsqy(provinceCode);
      scxm.setBuspName(provinceName);
      scxm.setBuscCode(cityCode);
      scxm.setBuscName(cityName);
      scxm.setBusdCode(districtCode);
      scxm.setBusdName(districtName);
      scxm.setSalesPersonId(salesPersonId);
      scxm.setSalesPersonName(salesPersonName);
      scxm.setPreSalesPersonId(preSalesPersonId);
      scxm.setPreSalesPersonName(preSalesPersonName);
      scxm.setPreSalesPersonDeptId(preSalesPersonDeptId);
      scxm.setPreSalesPersonDeptName(preSalesPersonDeptName);
      scxm.setHasAgent(hasAgent);
      scxm.setAgentId(agentId);
      scxm.setAgentName(agentName);
      scxm.setProjectRate(projectRate);
      scxm.setPlanSignDate(planSignDate);
      scxm.setProjectContent(projectContent);
      scxm.setCompetitorAnalysis(competitorAnalysis);
      scxm.setProjectEstablishmentDate(projectEstablishmentDate);
      scxm.setBusinessStage(businessStage);
      Serializable scxmId = s.save(scxm);
      String totalJoinLength = request.getParameter("totalJoinLength");
      for (int j = 1; j <= Integer.parseInt(totalJoinLength); j++) {
        String joinOrgId = request.getParameter("join_org_id_" + j);
        String joinOrgName = request.getParameter("join_org_name_" + j);
        String joinDeptId = request.getParameter("join_dept_id_" + j);
        String joinDeptName = request.getParameter("join_dept_name_" + j);
        String joinUserId = request.getParameter("join_user_id_" + j);
        String joinUserName = request.getParameter("join_user_name_" + j);
        String joinRatio = request.getParameter("join_ratio_" + j);
        ScxmJoin scxmJoin = new ScxmJoin();
        scxmJoin.setScxmId(scxmId.toString());
        scxmJoin.setJoinOrgId(joinOrgId);
        scxmJoin.setJoinOrgName(joinOrgName);
        scxmJoin.setJoinDeptId(joinDeptId);
        scxmJoin.setJoinDeptName(joinDeptName);
        scxmJoin.setJoinUserId(joinUserId);
        scxmJoin.setJoinUserName(joinUserName);
        scxmJoin.setRatio(joinRatio);
        Long id = Long.valueOf(userForm.getId());
        scxmJoin.setCreateUserId(id.toString());
        scxmJoin.setCreateUserName(userForm.getUserName());
        scxmJoin.setCreateTime(DateUtil.getCurrentTime());
        scxmJoin.setIsDeleted("0");
        scxmJoin.setSort(Integer.valueOf(j).toString());
        s.save(scxmJoin);
      } 
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=add&message=yes");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  private List<String> initJoinRatio(String value) {
    List<String> list = new ArrayList<String>();
    for (int i = 1; i <= 100; i++) {
      String selected = (i + "").equals(value) ? "selected" : "";
      String str = "<option value='" + i + "' " + selected + ">" + i + "%</option>";
      list.add(str);
    } 
    return list;
  }
  
  public ActionForward edit(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    try {
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      request.setAttribute("scxm", scxm);
      List regList = s.createQuery("SELECT reg FROM Region reg WHERE reg.regionLevel='2' and reg.isDelete='0' order by  reg.regionCode ").list();
      request.setAttribute("regList", regList);
      Query queryUser = s.createQuery(" FROM User user WHERE user.isDeleted='0' and user.deptID=:deptID ");
      queryUser.setParameter("deptID", Long.valueOf(userForm.getDeptID()));
      List listUser = queryUser.list();
      List disOrgList = s.createQuery("SELECT d FROM DistributionOrg d WHERE d.isDeleted='0' ORDER BY d.name ").list();
      List listDept = s.createQuery(" FROM Dept dept WHERE dept.isDeleted='0' ORDER BY dept.sortID ").list();
      List<ScxmJoin> scxmJoinList = s.createQuery("SELECT sc FROM ScxmJoin sc WHERE sc.isDeleted='0' and sc.scxmId= " + id + " order by sc.sort ").list();
      String org_sql = "SELECT org FROM Org org WHERE org.isDeleted='0' AND org.lx in('1','2','3','4') ORDER BY org.id,org.orgName";
      Query org_query = s.createQuery(org_sql);
      List<Org> orgList = org_query.list();
      List<ScxmJoinVo> voList = new ArrayList<ScxmJoinVo>();
      for (ScxmJoin scxmJoin : scxmJoinList) {
        ScxmJoinVo scxmJoinVo = new ScxmJoinVo();
        BeanUtils.copyProperties(scxmJoinVo, scxmJoin);
        List<Dept> deptList = s.createQuery(" FROM Dept dept WHERE dept.isDeleted='0' and dept.orgID='" + scxmJoinVo.getJoinOrgId() + "' ORDER BY dept.sortID ").list();
        List<User> userList = s.createQuery(" FROM User user WHERE user.isDeleted='0' and user.deptID= '" + scxmJoinVo.getJoinDeptId() + "'").list();
        List<String> ratioList = initJoinRatio(scxmJoinVo.getRatio());
        scxmJoinVo.setOrgList(orgList);
        scxmJoinVo.setDeptList(deptList);
        scxmJoinVo.setUserList(userList);
        scxmJoinVo.setRatioList(ratioList);
        voList.add(scxmJoinVo);
      } 
      String query_workFlow_sql = "SELECT work FROM WorkFlowInfo work  where work.workFlowCode=:workFlowCode AND work.isDeleted = '0' AND work.orgId=:orgId";
      Query scxsQuery = s.createQuery(query_workFlow_sql);
      String workFlowCode = WorkFlowUitl.getWorkFlowCode("ScxmApplication", Long.valueOf(userForm.getOrgID()).toString(), "1");
      scxsQuery.setString("workFlowCode", workFlowCode);
      scxsQuery.setString("orgId", Long.valueOf(userForm.getOrgID()).toString());
      WorkFlowInfo work = (WorkFlowInfo)scxsQuery.uniqueResult();
      List<WorkFlowTache> tacheList = null;
      if (work != null) {
        String query_tache_sql = "select tache from WorkFlowTache tache where tache.workFlowId=:workFlowId AND tache.isDeleted='0' order by tache.sortId";
        Query tache_query = s.createQuery(query_tache_sql);
        tache_query.setString("workFlowId", work.getId());
        tacheList = tache_query.list();
      } 
      WorkFlowTache currentTache = null;
      if (tacheList != null && tacheList.size() > 0)
        currentTache = tacheList.get(0); 
      request.setAttribute("currentTache", currentTache);
      WorkFlowTache nextTache = WorkFlowUitl.getNextTacheInfo("逐级审批", currentTache.getId(), s);
      request.setAttribute("nextTache", nextTache);
      List listLead = s.createQuery(" SELECT user FROM User user WHERE user.id= :userId ").setParameter("userId", userForm.getSuperiorLeaderId()).list();
      request.setAttribute("listLead", listLead);
      request.setAttribute("orgList", orgList);
      request.setAttribute("scxmJoinList", voList);
      request.setAttribute("listDept", listDept);
      request.setAttribute("disOrgList", disOrgList);
      request.setAttribute("listUser", listUser);
      return mapping.findForward("edit");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward dbsj(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      String sql = " SELECT  scxm  From Scxm scxm WHERE scxm.shirId='" + userForm.getId() + "' order by scxm.updateTime desc, scxm.createTime  desc ";
      Session s = HibernateUtil.currentSession();
      request.getSession().setAttribute("urlFrom", "dbsj");
      List listDbsj = s.createQuery(sql).list();
      request.setAttribute("listDbsj", listDbsj);
      return mapping.findForward("dbsj");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward yjtx(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      String[] purview = userForm.getPurviews().split(",");
      boolean scbld = false;
      Calendar calendar = Calendar.getInstance();
      calendar.add(5, 30);
      SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
      String NDate = formatter.format(calendar.getTime());
      String sqlHt = " SELECT  scxmQdzx  From Scxm scxm,ScxmQdzx scxmQdzx WHERE scxm.id=scxmQdzx.scxmID and (scxm.state !='4' and  scxm.state !='3') and scxm.xmjd='2' and scxmQdzx.isDeleted='0' and scxmQdzx.htjssj<'" + NDate + "' and scxm.createOrgId=" + userForm.getOrgID() + " order by scxm.createTime desc ";
      String sqlYw = " SELECT  scxmYw  From Scxm scxm,ScxmYw scxmYw WHERE scxm.id=scxmYw.scxmID and (scxm.state !='4' and scxm.state !='3') and scxm.xmjd='3' and scxmYw.isDeleted='0' and scxmYw.ywjssj<'" + NDate + "' and scxm.createOrgId=" + userForm.getOrgID() + " order by scxm.createTime desc ";
      Session s = HibernateUtil.currentSession();
      List listHtdq = s.createQuery(sqlHt).list();
      request.setAttribute("listHtdq", listHtdq);
      List listYwdq = s.createQuery(sqlYw).list();
      request.setAttribute("listYwdq", listYwdq);
      return mapping.findForward("yjtx");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward update(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      TaskForm taskForm = (TaskForm)form;
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      String xmmc = request.getParameter("xmmc");
      String xmlx = request.getParameter("xmlx");
      String xmjd = request.getParameter("xmjd");
      String zyx = request.getParameter("zyx");
      String bwd = request.getParameter("bwd");
      String ysje = request.getParameter("ysje");
      String ssqy = request.getParameter("ssqy");
      String jsdw = request.getParameter("jsdw");
      String lxr = request.getParameter("lxr");
      String lxdh = request.getParameter("lxdh");
      String bz = request.getParameter("bz");
      String type = request.getParameter("type");
      String businessOpportunityCode = request.getParameter("businessOpportunityCode");
      String businessType = request.getParameter("businessType");
      String fundSource = request.getParameter("fundSource");
      String isGreat = request.getParameter("isGreat");
      String wholeBudget = request.getParameter("wholeBudget");
      String businessOpportunityType = request.getParameter("businessOpportunityType");
      String provinceCode = request.getParameter("provinceCode");
      String provinceName = request.getParameter("provinceName");
      String cityCode = request.getParameter("cityCode");
      String cityName = request.getParameter("cityName");
      String districtCode = request.getParameter("districtCode");
      String districtName = request.getParameter("districtName");
      String salesDeptId = StringUtils.isNotEmpty(request.getParameter("deptID")) ? request.getParameter("deptID").trim() : "";
      String salesDeptName = StringUtils.isNotEmpty(request.getParameter("deptName")) ? request.getParameter("deptName").trim() : "";
      String salesPersonId = StringUtils.isNotEmpty(request.getParameter("userID")) ? request.getParameter("userID").trim() : "";
      String salesPersonName = StringUtils.isNotEmpty(request.getParameter("userName")) ? request.getParameter("userName").trim() : "";
      String preSalesPersonDeptName = StringUtils.isNotEmpty(request.getParameter("preDeptName")) ? request.getParameter("preDeptName").trim() : "";
      String preSalesPersonDeptId = StringUtils.isNotEmpty(request.getParameter("preDeptID")) ? request.getParameter("preDeptID").trim() : "";
      String preSalesPersonId = StringUtils.isNotEmpty(request.getParameter("preUserID")) ? request.getParameter("preUserID").trim() : "";
      String preSalesPersonName = StringUtils.isNotEmpty(request.getParameter("preUserName")) ? request.getParameter("preUserName").trim() : "";
      String hasAgent = request.getParameter("hasAgent");
      String agentId = request.getParameter("agentId");
      String agentName = request.getParameter("agentName");
      String projectRate = request.getParameter("projectRate");
      String planSignDate = request.getParameter("planSignDate");
      String projectContent = request.getParameter("projectContent");
      String competitorAnalysis = request.getParameter("competitorAnalysis");
      String projectEstablishmentDate = request.getParameter("projectEstablishmentDate");
      String shrID = request.getParameter("shrID");
      String nextTacheId = request.getParameter("nextTacheId");
      String nextTacheName = request.getParameter("nextTacheName");
      String businessStage = request.getParameter("businessStage");
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      MultipartRequestHandler mrh = taskForm.getMultipartRequestHandler();
      Hashtable elements = mrh.getFileElements();
      Collection values = elements.values();
      for (Iterator<FormFile> i = values.iterator(); i.hasNext(); ) {
        FormFile file = i.next();
        String fileName = file.getFileName();
        String dir = this.servlet.getServletContext().getRealPath("/file");
        if (file != null && fileName.length() > 4) {
          scxm.setFileName(fileName);
          dir = dir + "/";
          InputStream streamIn = file.getInputStream();
          Random randoms = new Random();
          int intrandom = randoms.nextInt();
          OutputStream streamOut = new FileOutputStream(dir + intrandom + fileName);
          scxm.setSaveName(intrandom + fileName);
          int bytesRead = 0;
          byte[] buffer = new byte[8192];
          while ((bytesRead = streamIn.read(buffer, 0, 8192)) != -1)
            streamOut.write(buffer, 0, bytesRead); 
          streamOut.close();
          streamIn.close();
          file.destroy();
        } 
      } 
      scxm.setXmmc(xmmc);
      scxm.setXmlx(xmlx);
      scxm.setXmjd(xmjd);
      scxm.setZyx(zyx);
      scxm.setBwd(bwd);
      scxm.setYsje(ysje);
      scxm.setJsdw(jsdw);
      scxm.setSsqy(ssqy);
      scxm.setLxdh(lxdh);
      scxm.setLxr(lxr);
      scxm.setBz(bz);
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setState("1");
      scxm.setType(type);
      scxm.setShirId(shrID);
      scxm.setCurrentTacheId(nextTacheId);
      scxm.setCurrentTacheName(nextTacheName);
      scxm.setBusinessOpportunityCode(businessOpportunityCode);
      scxm.setBusinessType(businessType);
      scxm.setFundSource(fundSource);
      scxm.setIsGreat(isGreat);
      scxm.setWholeBudget(wholeBudget);
      scxm.setBusinessOpportunityType(businessOpportunityType);
      scxm.setSsqy(provinceCode);
      scxm.setBuspName(provinceName);
      scxm.setBuscCode(cityCode);
      scxm.setBuscName(cityName);
      scxm.setBusdCode(districtCode);
      scxm.setBusdName(districtName);
      scxm.setSalesPersonId(salesPersonId);
      scxm.setSalesPersonName(salesPersonName);
      scxm.setPreSalesPersonId(preSalesPersonId);
      scxm.setPreSalesPersonName(preSalesPersonName);
      scxm.setPreSalesPersonDeptId(preSalesPersonDeptId);
      scxm.setPreSalesPersonDeptName(preSalesPersonDeptName);
      scxm.setHasAgent(hasAgent);
      scxm.setAgentId(agentId);
      scxm.setAgentName(agentName);
      scxm.setProjectRate(projectRate);
      scxm.setPlanSignDate(planSignDate);
      scxm.setProjectContent(projectContent);
      scxm.setCompetitorAnalysis(competitorAnalysis);
      scxm.setProjectEstablishmentDate(projectEstablishmentDate);
      scxm.setBusinessStage(businessStage);
      s.update(scxm);
      List<ScxmJoin> scxmJoinList = s.createQuery("SELECT sc FROM ScxmJoin sc WHERE sc.isDeleted='0' and sc.scxmId= " + id + " order by sc.sort ").list();
      for (ScxmJoin scxmJoin : scxmJoinList) {
        scxmJoin.setDeleteTime(DateUtil.getCurrentTime());
        scxmJoin.setIsDeleted("1");
        s.update(scxmJoin);
      } 
      String totalJoinLength = request.getParameter("totalJoinLength");
      String joinCreateTime = request.getParameter("joinCreateTime");
      for (int j = 1; j <= Integer.parseInt(totalJoinLength); j++) {
        String joinOrgId = request.getParameter("join_org_id_" + j);
        String joinOrgName = request.getParameter("join_org_name_" + j);
        String joinDeptId = request.getParameter("join_dept_id_" + j);
        String joinDeptName = request.getParameter("join_dept_name_" + j);
        String joinUserId = request.getParameter("join_user_id_" + j);
        String joinUserName = request.getParameter("join_user_name_" + j);
        String joinRatio = request.getParameter("join_ratio_" + j);
        ScxmJoin scxmJoin = new ScxmJoin();
        scxmJoin.setScxmId(scxm.getId());
        scxmJoin.setJoinOrgId(joinOrgId);
        scxmJoin.setJoinOrgName(joinOrgName);
        scxmJoin.setJoinDeptId(joinDeptId);
        scxmJoin.setJoinDeptName(joinDeptName);
        scxmJoin.setJoinUserId(joinUserId);
        scxmJoin.setJoinUserName(joinUserName);
        scxmJoin.setRatio(joinRatio);
        Long userId = Long.valueOf(userForm.getId());
        scxmJoin.setCreateUserId(scxm.getCjrID());
        scxmJoin.setCreateUserName(scxm.getCjr());
        scxmJoin.setCreateTime(DateUtil.getCurrentTime());
        scxmJoin.setUpdateUserId(userId.toString());
        scxmJoin.setUpdateUserName(userForm.getUserName());
        scxmJoin.setUpdateTime(DateUtil.getCurrentTime());
        scxmJoin.setIsDeleted("0");
        scxmJoin.setSort(Integer.valueOf(j).toString());
        s.save(scxmJoin);
      } 
      s.flush();
      if ("dbsj".equals(request.getSession().getAttribute("urlFrom"))) {
        response.sendRedirect("/tms/ScxsAction.do?dispatch=dbsj");
      } else {
        response.sendRedirect("/tms/ScxsAction.do?dispatch=goToPage");
      } 
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward deleted(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      scxm.setState("4");
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=goToPage");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward zx(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      scxm.setState("3");
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.update(scxm);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=goToPage");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward query(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    try {
      Session s = HibernateUtil.currentSession();
      TaskForm taskForm = (TaskForm)form;
      Map<String, Object> paramMap = new HashMap<String, Object>();
      String searchType = request.getParameter("type");
      String xmmc = request.getParameter("xmmc");
      String xmlx = request.getParameter("xmlx");
      String xmjd = request.getParameter("xmjd");
      String zyx = request.getParameter("zyx");
      String bwd = request.getParameter("bwd");
      String ssqy = request.getParameter("ssqy");
      String jsdw = request.getParameter("jsdw");
      String cjrID = request.getParameter("userID");
      String deptID = request.getParameter("deptID");
      String scxmMonth = request.getParameter("scxmMonth");
      String type = request.getParameter("type");
      String orgId = request.getParameter("orgId");
      String[] state = request.getParameterValues("state");
      String zxType = request.getParameter("zxType");
      String scxmYear = request.getParameter("scxmYear");
      String createStartTime = request.getParameter("qdkssj");
      String createEndTime = request.getParameter("qdjssj");
      String beginTime = request.getParameter("kssj");
      String endTime = request.getParameter("jssj");
      String createDeptID = request.getParameter("createDeptID");
      String createUserID = request.getParameter("createUserID");
      String preDeptID = request.getParameter("preDeptID");
      String preUserID = request.getParameter("preUserID");
      String contain = request.getParameter("contain");
      String businessOpportunityCode = request.getParameter("businessOpportunityCode");
      String[] purview = userForm.getPurviews().split(",");
      boolean bmjl = false;
      boolean gly = false;
      boolean fzc = false;
      boolean org_Query = false;
      for (int i = 0; i < purview.length; i++) {
        if ("431".equals(purview[i]) || "447".equals(purview[i])) {
          gly = true;
        } else if ("430".equals(purview[i])) {
          fzc = true;
        } 
        if ("108".equals(purview[i]))
          bmjl = true; 
        if ("908".equals(purview[i]))
          org_Query = true; 
      } 
      StringBuffer string = new StringBuffer();
      string.append(" SELECT  scxm FROM  Scxm scxm WHERE 1=1   ");
      if (xmmc != null && !"".equals(xmmc)) {
        string.append(" AND scxm.xmmc like :xmmc ");
        paramMap.put("xmmc", "%" + xmmc + "%");
      } 
      if (xmlx != null && !"".equals(xmlx))
        string.append(" AND scxm.xmlx='" + xmlx + "' "); 
      if (xmjd != null && !"".equals(xmjd))
        string.append(" AND scxm.xmjd='" + xmjd + "' "); 
      if (zyx != null && !"".equals(zyx))
        string.append(" AND scxm.zyx='" + zyx + "' "); 
      if (bwd != null && !"".equals(bwd))
        string.append(" AND scxm.bwd='" + bwd + "' "); 
      if (ssqy != null && !"".equals(ssqy))
        string.append(" AND scxm.ssqy='" + ssqy + "' "); 
      if (jsdw != null && !"".equals(jsdw)) {
        string.append(" AND scxm.jsdw like :jsdw ");
        paramMap.put("jsdw", "%" + jsdw + "%");
      } 
      if (cjrID != null && !"".equals(cjrID))
        string.append(" AND scxm.cjrID='" + cjrID + "' "); 
      if (businessOpportunityCode != null && !"".equals(businessOpportunityCode))
        string.append(" AND scxm.businessOpportunityCode='" + businessOpportunityCode + "' "); 
      if (deptID != null && !"".equals(deptID)) {
        if ("5681".equals(deptID) || userForm.getId() == 141L) {
          if ("1".equals(contain)) {
            string.append(" AND (scxm.cjrDeptID in('5681','5961','6061','6261','6262','104') ");
            string.append("  \tOR EXISTS(");
            string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id  and jon.joinDeptId IN('5681','5961','6061','6261','6262') ");
            string.append("\t\t))");
          } else {
            string.append(" AND (scxm.cjrDeptID='" + deptID + "' ");
            string.append("  \tOR EXISTS(");
            string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinDeptId=" + deptID);
            string.append("\t\t))");
          } 
        } else {
          string.append(" AND (scxm.cjrDeptID='" + deptID + "' ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinDeptId=" + deptID);
          string.append("\t\t))");
        } 
      } else if (!gly && !org_Query) {
        if (userForm.getDeptID() == 5681L || userForm.getId() == 141L) {
          string.append(" AND (scxm.cjrDeptID IN('5681','5961','6061','6261','6262','104') ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id  and jon.joinDeptId IN('5681','5961','6061','6261','6262') ");
          string.append("\t\t))");
        } else if (userForm.getDeptID() == 5681L || userForm.getDeptID() == 5961L || userForm.getDeptID() == 6061L || userForm
          .getDeptID() == 6261L || userForm.getDeptID() == 6262L) {
          string.append(" AND (scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id  and jon.joinDeptId IN('5681','5961','6061','6261','6262') ");
          string.append("\t\t))");
        } else {
          string.append(" AND (scxm.cjrDeptID='" + userForm.getDeptID() + "' ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinDeptId=" + userForm.getDeptName());
          string.append("\t\t))");
        } 
      } 
      if (beginTime != null && !"".equals(beginTime))
        string.append(" AND scxm.updateTime  > '" + beginTime + "' "); 
      if (endTime != null && !"".equals(endTime))
        string.append(" AND scxm.updateTime  < '" + endTime + " 24 ' "); 
      if (createDeptID != null && !"".equals(createDeptID)) {
        string.append(" AND scxm.cjrDeptID='" + createDeptID + "' ");
      } else if (!gly && !org_Query) {
        if (userForm.getDeptID() == 5681L || userForm.getId() == 141L) {
          string.append(" AND (scxm.cjrDeptID IN('5681','5961','6061','6261','6262','104') ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id  and jon.joinDeptId IN('5681','5961','6061','6261','6262') ");
          string.append("\t\t))");
        } else if (userForm.getDeptID() == 5681L || userForm.getDeptID() == 5961L || userForm.getDeptID() == 6061L || userForm
          .getDeptID() == 6261L || userForm.getDeptID() == 6262L) {
          string.append(" AND (scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinDeptId IN('5681','5961','6061','6261','6262') ");
          string.append("\t\t))");
        } else {
          string.append(" AND (scxm.cjrDeptID='" + userForm.getDeptID() + "' ");
          string.append("  \tOR EXISTS(");
          string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinDeptId=" + userForm.getDeptID());
          string.append("\t\t))");
        } 
      } 
      if (createUserID != null && !"".equals(createUserID))
        string.append(" AND scxm.salesPersonId='" + createUserID + "' "); 
      if (preDeptID != null && !"".equals(preDeptID))
        string.append(" AND scxm.preSalesPersonDeptId='" + preDeptID + "' "); 
      if (preUserID != null && !"".equals(preUserID))
        string.append(" AND scxm.preSalesPersonId='" + preUserID + "' "); 
      if (createStartTime != null && !"".equals(createStartTime))
        string.append(" AND scxm.createTime  > '" + createStartTime + "' "); 
      if (createEndTime != null && !"".equals(createEndTime))
        string.append(" AND scxm.createTime  < '" + createEndTime + " 24 ' "); 
      if (type != null && !"".equals(type))
        string.append(" AND scxm.type  = '" + type + "' "); 
      if (!"".equals(scxmYear) && scxmYear != null)
        string.append(" AND scxm.updateTime  >= '" + scxmYear + "-01-01 00:00:00'  AND scxm.updateTime<= '" + scxmYear + "-12-31 23:59:59' "); 
      if (scxmMonth != null && !"".equals(scxmMonth)) {
        string.append(" AND scxm.updateTime  > '" + scxmYear + scxmMonth + "' ");
        string.append(" AND scxm.updateTime  < '" + scxmYear + scxmMonth + "-32' ");
      } 
      if (!"".equals(zxType) && zxType != null)
        if ("0".equals(zxType)) {
          string.append(" AND scxm.zbje is null ");
        } else if ("1".equals(zxType)) {
          string.append(" AND scxm.type='1' AND scxm.xmjd='1' ");
        } else if ("2".equals(zxType)) {
          string.append(" AND scxm.zbje is not null AND (scxm.type='0' or (scxm.type='1' AND scxm.xmjd<>'1')) ");
        }  
      if (state != null && state.length > 0) {
        string.append(" AND ( 1=2  ");
        for (int j = 0; j < state.length; j++) {
          String stateValue = state[j];
          string.append(" or scxm.state='" + stateValue + "' ");
        } 
        string.append(" ) ");
      } 
      if (orgId != null && !"".equals(orgId)) {
        string.append(" and (scxm.createOrgId=" + orgId);
        string.append("  \tOR EXISTS(");
        string.append("  \t\tselect jon.id from ScxmJoin jon where jon.isDeleted='0' and jon.joinUserId='" + userForm.getId() + "' and jon.scxmId=scxm.id and jon.joinOrgId= " + orgId);
        string.append("\t\t))");
      } 
      string.append("   ORDER BY   scxm.updateTime desc, scxm.createTime  desc ");
      System.out.println("==========================");
      System.out.println(string.toString());
      System.out.println("==========================");
      scxmTotal(string.toString(), paramMap, orgId, s, request);
      HibernatePage pager = new HibernatePage();
      Query query1 = s.createQuery(string.toString());
      if (paramMap != null && paramMap.size() > 0)
        for (String key : paramMap.keySet())
          query1.setParameter(key, paramMap.get(key));  
      List<Scxm> list1 = query1.list();
      int count = 0;
      if (list1 != null && list1.size() > 0)
        for (int j = 0; j < list1.size(); j++) {
          Scxm scxm = list1.get(j);
          if ("2255".equals(scxm.getId()) || "2256".equals(scxm.getId()) || "2925".equals(scxm.getId()) || "3210"
            .equals(scxm.getId())) {
            StringBuffer sb = new StringBuffer();
            sb.append(" FROM Contract t WHERE  t.isDeleted='0' AND t.createOrgId=" + userForm.getOrgID() + " ");
            sb.append(" AND t.scxmID='" + scxm.getId() + "' ");
            sb.append("  ORDER BY t.createTime DESC ");
            List allList = s.createQuery(sb.toString()).list();
            System.out.println("allList" + allList.size());
            count += allList.size();
          } 
        }  
      List list = HibernatePageHelper.getPageListByParameter(string.toString(), pager, paramMap);
      request.getSession().setAttribute("orgId", orgId);
      request.getSession().setAttribute("count", count + "");
      request.getSession().setAttribute("pageObject", pager);
      request.getSession().setAttribute("paramMap", paramMap);
      request.setAttribute("list", list);
      return mapping.findForward("queryResult");
    } catch (Exception e) {
      log.error(e);
      e.printStackTrace();
      return null;
    } 
  }
  
  public void scxmTotal(String hql, Map<String, Object> paramMap, String orgId, Session s, HttpServletRequest request) {
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    Query query = s.createQuery(hql);
    if (paramMap != null && paramMap.size() > 0)
      for (String key : paramMap.keySet())
        query.setParameter(key, paramMap.get(key));  
    List<Scxm> scxmList = query.list();
    StringBuffer sbfBuffer = new StringBuffer();
    sbfBuffer.append(" SELECT  scxm FROM  Scxm scxm WHERE 1=1  AND ( scxm.state='1' OR scxm.state='2') ");
    if (!"".equals(orgId) && orgId != null)
      sbfBuffer.append(" AND scxm.createOrgId=:createOrgId "); 
    sbfBuffer.append(" ORDER BY scxm.updateTime desc, scxm.createTime  desc ");
    Query q = s.createQuery(sbfBuffer.toString());
    if (!"".equals(orgId) && orgId != null)
      q.setParameter("createOrgId", (orgId == null) ? "" : orgId); 
    List<Scxm> allList = q.list();
    BigDecimal allyzbSum = new BigDecimal(0);
    BigDecimal allysjeSum = new BigDecimal(0);
    BigDecimal allsyysjeSum = new BigDecimal(0);
    if (allList != null && allList.size() > 0)
      for (int i = 0; i < allList.size(); i++) {
        Scxm scxm = allList.get(i);
        if (!"".equals(scxm.getYsje()) && scxm.getYsje() != null) {
          allysjeSum = allysjeSum.add(new BigDecimal(scxm.getYsje()));
          allyzbSum = allyzbSum.add(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
          if ("1".equals(scxm.getType())) {
            allsyysjeSum = allsyysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje())).subtract(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
          } else if ("".equals(scxm.getZbje()) || scxm.getZbje() == null) {
            allsyysjeSum = allsyysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje()));
          } 
        } 
      }  
    request.setAttribute("allysjeSum", allysjeSum);
    request.setAttribute("allyzbSum", allyzbSum);
    request.setAttribute("allsyysjeSum", allsyysjeSum);
    BigDecimal yzbSum = new BigDecimal(0);
    BigDecimal ysjeSum = new BigDecimal(0);
    BigDecimal syysjeSum = new BigDecimal(0);
    if (scxmList != null && scxmList.size() > 0)
      for (int i = 0; i < scxmList.size(); i++) {
        Scxm scxm = scxmList.get(i);
        if (!"".equals(scxm.getYsje()) && scxm.getYsje() != null) {
          ysjeSum = ysjeSum.add(new BigDecimal(scxm.getYsje()));
          yzbSum = yzbSum.add(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
        } 
        if ("1".equals(scxm.getType())) {
          syysjeSum = syysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje())).subtract(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
        } else if ("".equals(scxm.getZbje()) || scxm.getZbje() == null) {
          syysjeSum = syysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje()));
        } 
      }  
    request.setAttribute("ysjeSum", ysjeSum);
    request.setAttribute("yzbSum", yzbSum);
    request.setAttribute("syysjeSum", syysjeSum);
  }
  
  public void sjhzView(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws IOException {
    response.setContentType("text/html; charset=utf-8");
    PrintWriter out = response.getWriter();
    UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
    String role = userForm.getPurviews();
    Long roleId = Long.valueOf(userForm.getRoleID());
    if (role.indexOf("947") >= 0)
      roleId = Long.valueOf(947L); 
    Long userId = Long.valueOf(userForm.getId());
    String[] state = { "1", "2" };
    String orgId = null;
    List<SjhzVO> viewList = new ArrayList<SjhzVO>();
    SjhzTotalVO totalVO = new SjhzTotalVO();
    if (roleId.longValue() == 947L) {
      orgId = "1";
      SjhzVO view1 = sjhz(orgId, null, null, state, userForm, request);
      viewList.add(view1);
      SjhzVO view = sjhz(orgId, "5681", "　市场营销中心(含下级)", state, userForm, request);
      viewList.add(view);
      SjhzVO view2 = sjhz(orgId, "5961", "　　行业市场营销一部", state, userForm, request);
      viewList.add(view2);
      SjhzVO view3 = sjhz(orgId, "6061", "　　行业市场营销二部", state, userForm, request);
      viewList.add(view3);
      SjhzVO view4 = sjhz(orgId, "6261", "　　行业市场营销三部", state, userForm, request);
      viewList.add(view4);
      SjhzVO view5 = sjhz(orgId, "6262", "　　行业市场营销四部", state, userForm, request);
      viewList.add(view5);
      SjhzVO view6 = sjhz(orgId, "181", "　商务管理部", state, userForm, request);
      viewList.add(view6);
      SjhzVO view7 = sjhz(orgId, "5761", "　体检事业部", state, userForm, request);
      viewList.add(view7);
      orgId = "360";
      collectList(null, viewList, orgId, state, userForm, request);
      orgId = "320";
      collectList(null, viewList, orgId, state, userForm, request);
      orgId = "361";
      collectList(null, viewList, orgId, state, userForm, request);
      totalVO.setShow("1");
    } else if (userId.longValue() == 141L) {
      orgId = "1";
      SjhzVO view = sjhz(orgId, "5681", "　市场营销中心(含下级)", state, userForm, request);
      viewList.add(view);
      SjhzVO view2 = sjhz(orgId, "5961", "　　行业市场营销一部", state, userForm, request);
      viewList.add(view2);
      SjhzVO view3 = sjhz(orgId, "6061", "　　行业市场营销二部", state, userForm, request);
      viewList.add(view3);
      SjhzVO view4 = sjhz(orgId, "6261", "　　行业市场营销三部", state, userForm, request);
      viewList.add(view4);
      SjhzVO view5 = sjhz(orgId, "6262", "　　行业市场营销四部", state, userForm, request);
      viewList.add(view5);
      totalVO.setShow("0");
    } else if (userId.longValue() == 156L) {
      orgId = "1";
      SjhzVO view6 = sjhz(orgId, "181", "　商务管理部", state, userForm, request);
      viewList.add(view6);
      SjhzVO view7 = sjhz(orgId, "5761", "　体检事业部", state, userForm, request);
      viewList.add(view7);
      totalVO.setShow("0");
    } else if (userId.longValue() == 4050L) {
      orgId = "360";
      collectList(null, viewList, orgId, state, userForm, request);
      totalVO.setShow("1");
    } else if (userId.longValue() == 3956L) {
      orgId = "320";
      collectList(null, viewList, orgId, state, userForm, request);
      totalVO.setShow("1");
    } else if (userId.longValue() == 4891L) {
      orgId = "361";
      collectList(null, viewList, orgId, state, userForm, request);
      totalVO.setShow("1");
    } else {
      out.print("");
      out.close();
      return;
    } 
    totalVO.setViewList(viewList);
    BigDecimal total1 = BigDecimal.ZERO;
    BigDecimal total2 = BigDecimal.ZERO;
    BigDecimal total3 = BigDecimal.ZERO;
    BigDecimal total4 = BigDecimal.ZERO;
    for (SjhzVO sjhzVO : viewList) {
      if (StringUtils.isBlank(sjhzVO.getDeptId())) {
        total1 = total1.add(sjhzVO.getYsjeSumNum());
        total2 = total2.add(sjhzVO.getSyysjeSumNum());
        total3 = total3.add(sjhzVO.getYzbSumNum());
        total4 = total4.add(sjhzVO.getContractSumNum());
      } 
    } 
    totalVO.setTotal1(StringUtils.formatMoney(String.valueOf(total1.doubleValue() * 10000.0D), 2));
    totalVO.setTotal2(StringUtils.formatMoney(String.valueOf(total2.doubleValue() * 10000.0D), 2));
    totalVO.setTotal3(StringUtils.formatMoney(String.valueOf(total3.doubleValue() * 10000.0D), 2));
    totalVO.setTotal4(StringUtils.formatMoney(String.valueOf(total4.doubleValue()), 2));
    out.print(JSON.toJSONString(totalVO));
  }
  
  public void collectList(Map<String, String> currentDept, List<SjhzVO> viewList, String orgId, String[] state, UserForm userForm, HttpServletRequest request) {
    if (currentDept != null && currentDept.size() != 0) {
      for (String deptId : currentDept.keySet()) {
        String deptName = currentDept.get(deptId);
        SjhzVO view = sjhz(orgId, deptId, deptName, state, userForm, request);
        viewList.add(view);
      } 
    } else {
      SjhzVO view = sjhz(orgId, null, null, state, userForm, request);
      viewList.add(view);
    } 
  }
  
  public SjhzVO sjhz(String orgId, String deptID, String deptName, String[] state, UserForm userForm, HttpServletRequest request) {
    try {
      Session s = HibernateUtil.currentSession();
      String searchType = request.getParameter("type");
      String xmmc = request.getParameter("xmmc");
      String xmlx = request.getParameter("xmlx");
      String xmjd = request.getParameter("xmjd");
      String zyx = request.getParameter("zyx");
      String bwd = request.getParameter("bwd");
      String ssqy = request.getParameter("ssqy");
      String jsdw = request.getParameter("jsdw");
      String cjrID = request.getParameter("userID");
      String scxmMonth = request.getParameter("scxmMonth");
      String type = request.getParameter("type");
      String zxType = request.getParameter("zxType");
      String scxmYear = request.getParameter("scxmYear");
      if ("".equals(scxmYear) || scxmYear == null)
        scxmYear = DateUtil.getCurrentYear(); 
      String createStartTime = request.getParameter("qdkssj");
      String createEndTime = request.getParameter("qdjssj");
      String beginTime = request.getParameter("kssj");
      String endTime = request.getParameter("jssj");
      String createDeptID = request.getParameter("createDeptID");
      String createUserID = request.getParameter("createUserID");
      String preDeptID = request.getParameter("preDeptID");
      String preUserID = request.getParameter("preUserID");
      String contain = "1";
      String[] purview = userForm.getPurviews().split(",");
      boolean bmjl = false;
      boolean gly = false;
      boolean fzc = false;
      boolean org_Query = false;
      for (int i = 0; i < purview.length; i++) {
        if ("431".equals(purview[i]) || "447".equals(purview[i])) {
          gly = true;
        } else if ("430".equals(purview[i])) {
          fzc = true;
        } 
        if ("108".equals(purview[i]))
          bmjl = true; 
        if ("908".equals(purview[i]))
          org_Query = true; 
      } 
      StringBuffer string = new StringBuffer();
      string.append(" SELECT  scxm FROM  Scxm scxm WHERE 1=1   ");
      if (xmmc != null && !"".equals(xmmc))
        string.append(" AND scxm.xmmc like '%" + xmmc + "%' "); 
      if (xmlx != null && !"".equals(xmlx))
        string.append(" AND scxm.xmlx='" + xmlx + "' "); 
      if (xmjd != null && !"".equals(xmjd))
        string.append(" AND scxm.xmjd='" + xmjd + "' "); 
      if (zyx != null && !"".equals(zyx))
        string.append(" AND scxm.zyx='" + zyx + "' "); 
      if (bwd != null && !"".equals(bwd))
        string.append(" AND scxm.bwd='" + bwd + "' "); 
      if (ssqy != null && !"".equals(ssqy))
        string.append(" AND scxm.ssqy='" + ssqy + "' "); 
      if (jsdw != null && !"".equals(jsdw))
        string.append(" AND scxm.jsdw like '%" + jsdw + "%' "); 
      if (cjrID != null && !"".equals(cjrID))
        string.append(" AND scxm.cjrID='" + cjrID + "' "); 
      if (deptID != null && !"".equals(deptID)) {
        if ("5681".equals(deptID)) {
          if ("1".equals(contain)) {
            string.append(" AND scxm.cjrDeptID in('5681','5961','6061','6261','6262') ");
          } else {
            string.append(" AND scxm.cjrDeptID='" + deptID + "' ");
          } 
        } else {
          string.append(" AND scxm.cjrDeptID='" + deptID + "' ");
        } 
      } else if (!gly && !org_Query) {
        if (userForm.getDeptID() == 5681L || userForm.getId() == 141L) {
          string.append(" AND scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
        } else if (userForm.getDeptID() == 5965L || userForm.getDeptID() == 5964L || userForm.getDeptID() == 5963L || userForm
          .getDeptID() == 5962L || userForm.getDeptID() == 5961L) {
          string.append(" AND scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
        } else {
          string.append(" AND scxm.cjrDeptID='" + userForm.getDeptID() + "' ");
        } 
      } 
      if (beginTime != null && !"".equals(beginTime))
        string.append(" AND scxm.updateTime  > '" + beginTime + "' "); 
      if (endTime != null && !"".equals(endTime))
        string.append(" AND scxm.updateTime  < '" + endTime + " 24 ' "); 
      if (createDeptID != null && !"".equals(createDeptID)) {
        string.append(" AND scxm.cjrDeptID='" + createDeptID + "' ");
      } else if (!gly && !org_Query) {
        if (userForm.getDeptID() == 5681L || userForm.getId() == 141L) {
          string.append(" AND scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
        } else if (userForm.getDeptID() == 5961L || userForm.getDeptID() == 6061L || userForm.getDeptID() == 6261L || userForm
          .getDeptID() == 6262L) {
          string.append(" AND scxm.cjrDeptID IN('5681','5961','6061','6261','6262') ");
        } else {
          string.append(" AND scxm.cjrDeptID='" + userForm.getDeptID() + "' ");
        } 
      } 
      if (createUserID != null && !"".equals(createUserID))
        string.append(" AND scxm.salesPersonId='" + createUserID + "' "); 
      if (preDeptID != null && !"".equals(preDeptID))
        string.append(" AND scxm.preSalesPersonDeptId='" + preDeptID + "' "); 
      if (preUserID != null && !"".equals(preUserID))
        string.append(" AND scxm.preSalesPersonId='" + preUserID + "' "); 
      if (createStartTime != null && !"".equals(createStartTime))
        string.append(" AND scxm.createTime  > '" + createStartTime + "' "); 
      if (createEndTime != null && !"".equals(createEndTime))
        string.append(" AND scxm.createTime  < '" + createEndTime + " 24 ' "); 
      if (type != null && !"".equals(type))
        string.append(" AND scxm.type  = '" + type + "' "); 
      if (!"".equals(scxmYear) && scxmYear != null)
        string.append(" AND scxm.updateTime  >= '" + scxmYear + "-01-01 00:00:00'  AND scxm.updateTime<= '" + scxmYear + "-12-31 23:59:59' "); 
      if (scxmMonth != null && !"".equals(scxmMonth)) {
        string.append(" AND scxm.updateTime  > '" + scxmYear + scxmMonth + "' ");
        string.append(" AND scxm.updateTime  < '" + scxmYear + scxmMonth + "-32' ");
      } 
      if (!"".equals(zxType) && zxType != null)
        if ("0".equals(zxType)) {
          string.append(" AND scxm.zbje is null ");
        } else if ("1".equals(zxType)) {
          string.append(" AND scxm.type='1' AND scxm.xmjd='1' ");
        } else if ("2".equals(zxType)) {
          string.append(" AND scxm.zbje is not null AND (scxm.type='0' or (scxm.type='1' AND scxm.xmjd<>'1')) ");
        }  
      if (state != null && state.length > 0) {
        string.append(" AND ( 1=2  ");
        for (int j = 0; j < state.length; j++) {
          String stateValue = state[j];
          string.append(" or scxm.state='" + stateValue + "' ");
        } 
        string.append(" ) ");
      } 
      if (orgId != null && !"".equals(orgId))
        string.append(" and scxm.createOrgId=" + orgId); 
      string.append("   ORDER BY   scxm.updateTime desc, scxm.createTime  desc ");
      System.out.println("==========================");
      System.out.println(string.toString());
      System.out.println("==========================");
      Query query = s.createQuery(string.toString());
      List<Scxm> scxmList = query.list();
      SjhzVO view = new SjhzVO();
      BigDecimal yzbSum = new BigDecimal(0);
      BigDecimal ysjeSum = new BigDecimal(0);
      BigDecimal syysjeSum = new BigDecimal(0);
      if (scxmList != null && scxmList.size() > 0)
        for (int j = 0; j < scxmList.size(); j++) {
          Scxm scxm = scxmList.get(j);
          if (!"".equals(scxm.getYsje()) && scxm.getYsje() != null) {
            ysjeSum = ysjeSum.add(new BigDecimal(scxm.getYsje()));
            yzbSum = yzbSum.add(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
          } 
          if ("1".equals(scxm.getType())) {
            syysjeSum = syysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje())).subtract(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
          } else if ("".equals(scxm.getZbje()) || scxm.getZbje() == null) {
            syysjeSum = syysjeSum.add(new BigDecimal((scxm.getYsje() == null) ? "0" : scxm.getYsje()));
          } 
        }  
      if (deptID != null && !"".equals(deptID)) {
        view.setDeptName(deptName);
      } else if ("1".equals(orgId)) {
        view.setDeptName("北京梦天门科技股份有限公司");
      } else if ("320".equals(orgId)) {
        view.setDeptName("北京梦天门健康科技有限公司");
      } else if ("360".equals(orgId)) {
        view.setDeptName("智慧医卫");
      } else if ("361".equals(orgId)) {
        view.setDeptName("北京梦天门信息科技有限公司");
      } 
      view.setDeptId(deptID);
      view.setOrgId(orgId);
      view.setYzbSum(StringUtils.formatMoney(String.valueOf(yzbSum.doubleValue() * 10000.0D), 2));
      view.setSyysjeSum(StringUtils.formatMoney(String.valueOf(syysjeSum.doubleValue() * 10000.0D), 2));
      view.setYsjeSum(StringUtils.formatMoney(String.valueOf(ysjeSum.doubleValue() * 10000.0D), 2));
      view.setYzbSumNum(yzbSum);
      view.setSyysjeSumNum(syysjeSum);
      view.setYsjeSumNum(ysjeSum);
      view.setContractSumNum(getContractSum(userForm, deptID, orgId, scxmYear, contain));
      view.setContractSum(StringUtils.formatMoney(String.valueOf(view.getContractSumNum().doubleValue()), 2));
      return view;
    } catch (Exception e) {
      log.error(e);
      e.printStackTrace();
      return null;
    } 
  }
  
  public BigDecimal getContractSum(UserForm userForm, String deptID, String orgId, String contractYear, String contain) {
    Session s = HibernateUtil.currentSession();
    Map<String, Object> paramMap = new HashMap<String, Object>();
    String[] isDeleted = { "0" };
    String[] state = null;
    String userID = null;
    StringBuffer sb = new StringBuffer();
    sb.append("SELECT t FROM Contract t WHERE 1=1 ");
    sb.append(" AND t.createOrgId=:createOrgId ");
    if (!"".equals(orgId) && orgId != null) {
      paramMap.put("createOrgId", orgId);
    } else {
      paramMap.put("createOrgId", Long.valueOf(userForm.getOrgID()));
    } 
    if (isDeleted != null && isDeleted.length > 0) {
      sb.append(" AND( ");
      for (int i = 0; i < isDeleted.length; i++) {
        if (!"".equals(isDeleted[i]) && isDeleted[i] != null) {
          if (i == 0) {
            sb.append(" t.isDeleted=:isDeleted" + i + " ");
          } else {
            sb.append(" OR t.isDeleted=:isDeleted" + i + " ");
          } 
          paramMap.put("isDeleted" + i, isDeleted[i]);
        } 
      } 
      sb.append(" ) ");
    } 
    if (state != null && state.length > 0) {
      sb.append(" AND( ");
      for (int i = 0; i < state.length; i++) {
        if (!"".equals(state[i]) && state[i] != null) {
          if (i == 0) {
            sb.append(" t.state=:state" + i + " ");
          } else {
            sb.append(" OR t.state=:state" + i + " ");
          } 
          paramMap.put("state" + i, state[i]);
        } 
      } 
      sb.append(" ) ");
    } 
    if (!"".equals(contractYear) && contractYear != null) {
      sb.append(" AND t.createTime>=:contractYearStart AND t.createTime<=:contractYearEnd ");
      paramMap.put("contractYearStart", contractYear + "-01-01 00:00:00");
      paramMap.put("contractYearEnd", contractYear + "-12-31 23:59:59");
    } 
    if (StringUtils.isNotBlank(userID)) {
      sb.append(" AND t.createUserId=:userID ");
      paramMap.put("userID", userID);
    } else if (!"".equals(deptID) && deptID != null) {
      if ("5681".equals(deptID) && "1".equals(contain)) {
        sb.append(" AND t.createUserId IN(SELECT u.id FROM User u WHERE u.deptID IN (5681,5961,6061,6261,6262)) ");
      } else {
        sb.append(" AND t.createUserId IN(SELECT u.id FROM User u WHERE u.deptID=:deptID) ");
        paramMap.put("deptID", deptID);
      } 
    } else if (userForm.getId() == 141L || userForm.getId() == 3090L) {
      sb.append(" AND t.createUserId IN(SELECT u.id FROM User u WHERE u.deptID IN (5681,5961,6061,6261,6262)) ");
    } 
    sb.append("  ORDER BY t.createTime DESC ");
    BigDecimal contractSum = new BigDecimal(0);
    Map<String, Integer> contractNumMap = new HashMap<String, Integer>();
    System.out.println(sb.toString());
    Query query = s.createQuery(sb.toString());
    if (paramMap != null && paramMap.size() > 0)
      for (String key : paramMap.keySet())
        query.setParameter(key, paramMap.get(key));  
    List<Contract> contractList = query.list();
    if (contractList != null && contractList.size() > 0)
      for (int i = 0; i < contractList.size(); i++) {
        Contract contract = contractList.get(i);
        String priceStr = (contract.getPrice() == null) ? "0" : contract.getPrice().replaceAll(",", "");
        double price = Double.parseDouble(priceStr);
        contractSum = contractSum.add(BigDecimal.valueOf(price));
      }  
    return contractSum;
  }
  
  public Map<String, String> getDeptList(HttpServletRequest request, String orgId, Long userId) {
    Session session = HibernateUtil.currentSession();
    try {
      List<Dept> listDept = getDept(orgId, userId, session);
      Map<String, String> map = new LinkedHashMap<String, String>();
      for (int i = 0; i < listDept.size(); i++) {
        Dept dept = listDept.get(i);
        if (dept.getId() == 5961L || dept.getId() == 6061L || dept.getId() == 6261L || dept.getId() == 6262L) {
          map.put(String.valueOf(dept.getId()), "　　" + dept.getDeptName());
        } else {
          map.put(String.valueOf(dept.getId()), "　" + dept.getDeptName());
        } 
      } 
      return map;
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
  }
  
  public static List<Dept> getDept(String orgID, Long userId, Session session) throws Exception {
    StringBuffer sb = new StringBuffer();
    sb.append(" FROM Dept dept WHERE dept.isDeleted='0' ");
    if ("1".equals(orgID) && (userId.longValue() == 141L || userId.longValue() == 156L))
      sb.append(" AND (dept.id=5681 OR dept.id=5961 OR  dept.id=6061 OR  dept.id=6261 OR dept.id=6262 OR dept.id=5965 OR dept.id=181 OR dept.id=5761) "); 
    sb.append(" ORDER BY dept.sortID ");
    List<Dept> listDept = session.createQuery(sb.toString()).list();
    return listDept;
  }
  
  public ActionForward goToPage(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      Session s = HibernateUtil.currentSession();
      HibernatePage pager = (HibernatePage)request.getSession().getAttribute("pageObject");
      if (request.getParameter("pageNum") != null)
        pager.setCurrentPage(Integer.parseInt(request.getParameter("pageNum"))); 
      String orgId = (String)request.getSession().getAttribute("orgId");
      Map<String, Object> paramMap = (Map)request.getSession().getAttribute("paramMap");
      scxmTotal(pager.getQuerySQL(), paramMap, orgId, s, request);
      List list = HibernatePageHelper.getPageListByParameter(pager.getQuerySQL(), pager, paramMap);
      request.getSession().setAttribute("pageObject", pager);
      request.setAttribute("list", list);
      return mapping.findForward("queryResult");
    } catch (Exception e) {
      log.error("拟稿分页==" + e);
      e.printStackTrace();
      return null;
    } 
  }
  
  public ActionForward detail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      request.setAttribute("scxm", scxm);
      List listScxmPj = s.createQuery("SELECT scxmPj From ScxmPj scxmPj WHERE scxmPj.scxmID='" + id + "' and scxmPj.isDeleted='0' order by scxmPj.createTime desc ").list();
      List scxmJoinList = s.createQuery("SELECT sc FROM ScxmJoin sc WHERE sc.isDeleted='0' and sc.scxmId= " + id + " order by sc.sort ").list();
      request.setAttribute("scxmJoinList", scxmJoinList);
      request.setAttribute("listScxmPj", listScxmPj);
      request.setAttribute("xh", "1");
      request.setAttribute("urlForm", request.getParameter("urlForm"));
      return mapping.findForward("detail");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward shShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      WorkFlowTache currentTache = WorkFlowUitl.getWorkFlowTacheByTacheId(s, scxm.getCurrentTacheId());
      WorkFlowStepInfo stepInfo = WorkFlowUitl.getWorkFlowStepByStep(userForm, currentTache, scxm.getId(), s);
      request.setAttribute("listLead", stepInfo.getUserList());
      request.setAttribute("currentTache", currentTache);
      request.setAttribute("nextTache", stepInfo.getWorkFlowTache());
      request.setAttribute("scxm", scxm);
      List listScxmPj = s.createQuery("SELECT scxmPj From ScxmPj scxmPj WHERE scxmPj.scxmID='" + id + "' and scxmPj.isDeleted='0' order by scxmPj.createTime desc ").list();
      request.setAttribute("listScxmPj", listScxmPj);
      request.setAttribute("xh", "1");
      return mapping.findForward("shShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward shSave(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      String scxmID = request.getParameter("scxmID");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, scxmID);
      String shjg = request.getParameter("shjg");
      String shyj = request.getParameter("shyj");
      String nextTacheId = request.getParameter("nextTacheId");
      String nextTacheName = request.getParameter("nextTacheName");
      String shrID = request.getParameter("shrID");
      if ("1".equals(shjg)) {
        if ("完成".equals(nextTacheName.trim()))
          scxm.setState("2"); 
        scxm.setCurrentTacheName(nextTacheName.trim());
        scxm.setCurrentTacheId(nextTacheId.trim());
        scxm.setShirId(shrID);
      } else {
        scxm.setState("0");
        WorkFlowTache workFlowTache = WorkFlowUitl.getNextTacheInfo("申请", scxm.getCurrentTacheId(), s);
        scxm.setCurrentTacheId(workFlowTache.getId());
        scxm.setCurrentTacheName(workFlowTache.getTacheName());
        scxm.setShirId(scxm.getCjrID());
      } 
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      s.update(scxm);
      ScxmSh scxmSh = new ScxmSh();
      scxmSh.setCreateTime(StringUtils.getDateTime());
      scxmSh.setCjrID(userForm.getId() + "");
      scxmSh.setCjr(userForm.getUserName());
      scxmSh.setScxmID(scxmID);
      scxmSh.setSftg(shjg);
      scxmSh.setShyj(shyj);
      s.save(scxmSh);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=dbsj");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward zxShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      String xh = request.getParameter("xh");
      if (xh == null || "".equals(xh))
        xh = "1"; 
      request.setAttribute("scxm", scxm);
      request.setAttribute("xh", xh);
      return mapping.findForward("zxShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward pjShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      String xh = request.getParameter("xh");
      if (xh == null || "".equals(xh))
        xh = "1"; 
      request.setAttribute("scxm", scxm);
      request.setAttribute("xh", xh);
      return mapping.findForward("pjShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward pjSave(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      ScxmPj scxmPj = new ScxmPj();
      String scxmID = request.getParameter("scxmID");
      String pjjn = request.getParameter("pjjn");
      String sfjl = request.getParameter("sfjl");
      String jlje = request.getParameter("jlje");
      String pjnr = request.getParameter("pjnr");
      scxmPj.setSfjl(sfjl);
      if ("1".equals(sfjl))
        scxmPj.setJlje(jlje); 
      scxmPj.setPjjn(pjjn);
      scxmPj.setPjnr(pjnr);
      scxmPj.setScxmID(scxmID);
      scxmPj.setIsDeleted("0");
      scxmPj.setCjrID(userForm.getId() + "");
      scxmPj.setCjr(userForm.getUserName());
      scxmPj.setCreateTime(StringUtils.getDateTime());
      s.save(scxmPj);
      Scxm scxm = (Scxm)s.get(Scxm.class, scxmID);
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.update(scxm);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=goToPage");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmSqShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      List listScxmSq = s.createQuery("SELECT scxmSq From ScxmSq scxmSq WHERE scxmSq.scxmID='" + id + "' and  (scxmSq.isDeleted='0' or scxmSq.isDeleted='1' ) ORDER BY scxmSq.createTime desc").list();
      request.setAttribute("listScxmSq", listScxmSq);
      request.setAttribute("scxm", scxm);
      return mapping.findForward("scxmSqShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmQdzxShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      List listScxmQdzx = s.createQuery("SELECT scxmQdzx From ScxmQdzx scxmQdzx WHERE scxmQdzx.scxmID='" + id + "' and  (scxmQdzx.isDeleted='0' or scxmQdzx.isDeleted='1' ) ORDER BY scxmQdzx.createTime desc").list();
      request.setAttribute("listScxmQdzx", listScxmQdzx);
      request.setAttribute("scxm", scxm);
      return mapping.findForward("scxmQdzxShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmYwShow(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      List listScxmYw = s.createQuery("SELECT scxmYw From ScxmYw scxmYw WHERE scxmYw.scxmID='" + id + "' and  (scxmYw.isDeleted='0' or scxmYw.isDeleted='1' ) ORDER BY scxmYw.createTime desc").list();
      request.setAttribute("listScxmYw", listScxmYw);
      request.setAttribute("scxm", scxm);
      return mapping.findForward("scxmYwShow");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward addScxmSq(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      ScxmSq scxmSq = new ScxmSq();
      List<ScxmSq> listScxmSq = s.createQuery("SELECT scxmSq From ScxmSq scxmSq WHERE scxmSq.scxmID='" + id + "' and  scxmSq.isDeleted='0'  ORDER BY scxmSq.createTime desc ").list();
      if (listScxmSq != null && listScxmSq.size() > 0) {
        scxmSq = listScxmSq.get(0);
      } else {
        scxmSq.setLxr(scxm.getLxr());
        scxmSq.setLxrdh(scxm.getLxdh());
      } 
      request.setAttribute("scxm", scxm);
      request.setAttribute("scxmSq", scxmSq);
      return mapping.findForward("addScxmSq");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward addScxmQdzx(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      ScxmQdzx scxmQdzx = new ScxmQdzx();
      List<ScxmQdzx> listScxmSq = s.createQuery("SELECT scxmQdzx From ScxmQdzx scxmQdzx WHERE scxmQdzx.scxmID='" + id + "' and scxmQdzx.isDeleted='0' ORDER BY scxmQdzx.createTime desc ").list();
      if (listScxmSq != null && listScxmSq.size() > 0) {
        scxmQdzx = listScxmSq.get(0);
      } else {
        scxmQdzx.setLxr(scxm.getLxr());
        scxmQdzx.setLxrdh(scxm.getLxdh());
      } 
      request.setAttribute("scxm", scxm);
      request.setAttribute("scxmQdzx", scxmQdzx);
      return mapping.findForward("addScxmQdzx");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward addScxmYw(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      ScxmYw scxmYw = new ScxmYw();
      List<ScxmYw> listScxmSq = s.createQuery("SELECT scxmYw From ScxmYw scxmYw WHERE scxmYw.scxmID='" + id + "' and scxmYw.isDeleted='0' ORDER BY scxmYw.createTime desc ").list();
      if (listScxmSq != null && listScxmSq.size() > 0) {
        scxmYw = listScxmSq.get(0);
      } else {
        scxmYw.setLxr(scxm.getLxr());
        scxmYw.setLxrdh(scxm.getLxdh());
      } 
      request.setAttribute("scxm", scxm);
      request.setAttribute("scxmYw", scxmYw);
      return mapping.findForward("addScxmYw");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward saveScxmSq(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String scxmID = request.getParameter("scxmID");
      List<ScxmSq> listScxmSq = s.createQuery("SELECT scxmSq From ScxmSq scxmSq WHERE scxmSq.scxmID='" + scxmID + "' and  scxmSq.isDeleted='0'  ORDER BY scxmSq.createTime desc ").list();
      if (listScxmSq != null && listScxmSq.size() > 0) {
        ScxmSq scxmSqOld = listScxmSq.get(0);
        scxmSqOld.setIsDeleted("1");
        s.update(scxmSqOld);
        s.flush();
      } 
      String jn = request.getParameter("jn");
      String jd = request.getParameter("jd");
      String zyx = request.getParameter("zyx");
      String bwd = request.getParameter("bwd");
      String tbrq = request.getParameter("tbrq");
      String bz = request.getParameter("bz");
      String lxr = request.getParameter("lxr");
      String lxrdh = request.getParameter("lxrdh");
      String projectRate = request.getParameter("projectRate");
      String businessStage = request.getParameter("businessStage");
      ScxmSq scxmSq = new ScxmSq();
      scxmSq.setScxmID(scxmID);
      scxmSq.setJn(jn);
      scxmSq.setJd(jd);
      scxmSq.setZyx(zyx);
      scxmSq.setBwd(bwd);
      scxmSq.setBz(bz);
      scxmSq.setCjr(userForm.getUserName());
      scxmSq.setCjrID(userForm.getId() + "");
      scxmSq.setIsDeleted("0");
      scxmSq.setTbrq(tbrq);
      scxmSq.setLxr(lxr);
      scxmSq.setLxrdh(lxrdh);
      scxmSq.setCreateTime(StringUtils.getDateTime());
      scxmSq.setProjectRate(projectRate);
      scxmSq.setBusinessStage(businessStage);
      s.save(scxmSq);
      Scxm scxm = (Scxm)s.get(Scxm.class, scxmID);
      scxm.setZyx(zyx);
      scxm.setBwd(bwd);
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setProjectRate(projectRate);
      scxm.setBusinessStage(businessStage);
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.update(scxm);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=zxShow&id=" + scxmID + "&xh=1");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward saveScxmQdzx(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String scxmID = request.getParameter("scxmID");
      List<ScxmQdzx> listScxmQdzx = s.createQuery("SELECT scxmQdzx From ScxmQdzx scxmQdzx WHERE scxmQdzx.scxmID='" + scxmID + "' and scxmQdzx.isDeleted='0' ORDER BY scxmQdzx.createTime desc ").list();
      if (listScxmQdzx != null && listScxmQdzx.size() > 0) {
        ScxmQdzx scxmQdzxOld = listScxmQdzx.get(0);
        scxmQdzxOld.setIsDeleted("1");
        s.update(scxmQdzxOld);
        s.flush();
      } 
      String htmc = request.getParameter("htmc");
      String xmbh = request.getParameter("xmbh");
      String jd = request.getParameter("jd");
      String tbbzjzt = request.getParameter("tbbzjzt");
      String tbbzjje = request.getParameter("tbbzjje");
      String zbtzs = request.getParameter("zbtzs");
      String htkssj = request.getParameter("htkssj");
      String htjssj = request.getParameter("htjssj");
      String wjje = request.getParameter("wjje");
      String lxr = request.getParameter("lxr");
      String lxrdh = request.getParameter("lxrdh");
      String lybzjzt = request.getParameter("lybzjzt");
      String lybzjje = request.getParameter("lybzjje");
      String bz = request.getParameter("bz");
      ScxmQdzx scxmQdzx = new ScxmQdzx();
      scxmQdzx.setScxmID(scxmID);
      scxmQdzx.setHtjssj(htjssj);
      scxmQdzx.setHtkssj(htkssj);
      scxmQdzx.setHtmc(htmc);
      scxmQdzx.setJd(jd);
      scxmQdzx.setLxr(lxr);
      scxmQdzx.setLxrdh(lxrdh);
      scxmQdzx.setLybzjje(lybzjje);
      scxmQdzx.setLybzjzt(lybzjzt);
      scxmQdzx.setTbbzjje(tbbzjje);
      scxmQdzx.setTbbzjzt(tbbzjzt);
      scxmQdzx.setWjje(wjje);
      scxmQdzx.setXmbh(xmbh);
      scxmQdzx.setZbtzs(zbtzs);
      scxmQdzx.setBz(bz);
      scxmQdzx.setCjr(userForm.getUserName());
      scxmQdzx.setCjrID(userForm.getId() + "");
      scxmQdzx.setCreateTime(StringUtils.getDateTime());
      scxmQdzx.setIsDeleted("0");
      s.save(scxmQdzx);
      Scxm scxm = (Scxm)s.get(Scxm.class, scxmID);
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.update(scxm);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=zxShow&id=" + scxmID + "&xh=2");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward saveScxmYw(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String scxmID = request.getParameter("scxmID");
      List<ScxmYw> listScxmYw = s.createQuery("SELECT scxmYw From ScxmYw scxmYw WHERE scxmYw.scxmID='" + scxmID + "' and scxmYw.isDeleted='0' ORDER BY scxmYw.createTime desc ").list();
      if (listScxmYw != null && listScxmYw.size() > 0) {
        ScxmYw scxmYwOld = listScxmYw.get(0);
        scxmYwOld.setIsDeleted("1");
        s.update(scxmYwOld);
        s.flush();
      } 
      String ywkssj = request.getParameter("ywkssj");
      String ywjssj = request.getParameter("ywjssj");
      String bz = request.getParameter("bz");
      String lxr = request.getParameter("lxr");
      String lxrdh = request.getParameter("lxrdh");
      ScxmYw scxmYw = new ScxmYw();
      scxmYw.setScxmID(scxmID);
      scxmYw.setYwkssj(ywkssj);
      scxmYw.setYwjssj(ywjssj);
      scxmYw.setBz(bz);
      scxmYw.setCjr(userForm.getUserName());
      scxmYw.setCjrID(userForm.getId() + "");
      scxmYw.setIsDeleted("0");
      scxmYw.setLxr(lxr);
      scxmYw.setLxrdh(lxrdh);
      scxmYw.setCreateTime(StringUtils.getDateTime());
      s.save(scxmYw);
      Scxm scxm = (Scxm)s.get(Scxm.class, scxmID);
      scxm.setUpdateTime(StringUtils.getDateTime());
      scxm.setGxr(userForm.getUserName());
      scxm.setGxrID(userForm.getId() + "");
      scxm.setCjrDeptID(userForm.getDeptID() + "");
      scxm.setCjrDeptName(userForm.getDeptName());
      s.update(scxm);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=zxShow&id=" + scxmID + "&xh=3");
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmYwDeleted(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmYw scxmYw = (ScxmYw)s.get(ScxmYw.class, id);
      scxmYw.setIsDeleted("2");
      s.update(scxmYw);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=scxmYwShow&id=" + scxmYw.getScxmID());
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmSqDeleted(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmSq scxmSq = (ScxmSq)s.get(ScxmSq.class, id);
      scxmSq.setIsDeleted("2");
      s.update(scxmSq);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=scxmSqShow&id=" + scxmSq.getScxmID());
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmQdzxDeleted(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmQdzx scxmQdzx = (ScxmQdzx)s.get(ScxmQdzx.class, id);
      scxmQdzx.setIsDeleted("2");
      s.update(scxmQdzx);
      s.flush();
      response.sendRedirect("/tms/ScxsAction.do?dispatch=scxmQdzxShow&id=" + scxmQdzx.getScxmID());
      return null;
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmSqDetail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmSq scxmSq = (ScxmSq)s.get(ScxmSq.class, id);
      request.setAttribute("scxmSq", scxmSq);
      return mapping.findForward("scxmSqDetail");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmPjDetail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmPj scxmPj = (ScxmPj)s.get(ScxmPj.class, id);
      request.setAttribute("scxmPj", scxmPj);
      return mapping.findForward("scxmPjDetail");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmQdzxDetail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmQdzx scxmQdzx = (ScxmQdzx)s.get(ScxmQdzx.class, id);
      request.setAttribute("scxmQdzx", scxmQdzx);
      return mapping.findForward("scxmQdzxDetail");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmYwDetail(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      UserForm userForm = (UserForm)request.getSession().getAttribute("usersession");
      Session s = HibernateUtil.currentSession();
      String id = request.getParameter("id");
      ScxmYw scxmYw = (ScxmYw)s.get(ScxmYw.class, id);
      request.setAttribute("scxmYw", scxmYw);
      return mapping.findForward("scxmYwDetail");
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
      return null;
    } finally {
      HibernateUtil.closeSession();
    } 
  }
  
  public ActionForward scxmExport(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      HibernatePage pager = (HibernatePage)request.getSession().getAttribute("pageObject");
      String sql = pager.getQuerySQL();
      Session s = HibernateUtil.currentSession();
      List<Scxm> scxmList = s.createQuery(sql).list();
      String sqSql = " FROM ScxmSq sq WHERE sq.isDeleted<>'2' ORDER BY sq.createTime DESC";
      List<ScxmSq> sqList = s.createQuery(sqSql).list();
      String qdzxSql = " FROM ScxmQdzx qdzx WHERE qdzx.isDeleted<>'2' ORDER BY qdzx.createTime DESC";
      List<ScxmQdzx> qdzxList = s.createQuery(qdzxSql).list();
      String ywSql = " FROM ScxmYw yw WHERE yw.isDeleted<>'2' ORDER BY yw.createTime DESC";
      List<ScxmYw> ywList = s.createQuery(ywSql).list();
      BigDecimal yzbSum = new BigDecimal(0);
      BigDecimal ysjeSum = new BigDecimal(0);
      BigDecimal tbbzjSum = new BigDecimal(0);
      BigDecimal wjjeSum = new BigDecimal(0);
      BigDecimal lyjjeSum = new BigDecimal(0);
      String rootPath = request.getSession().getServletContext().getRealPath("/");
      if (!rootPath.endsWith("/"))
        rootPath = rootPath + "/"; 
      String fileName = "梦天门销售商机管理表.xls";
      HSSFWorkbook workbook = new HSSFWorkbook();
      HSSFSheet sheet = workbook.createSheet();
      sheet.setDefaultColumnWidth((short)11);
      sheet.setColumnWidth((short)0, (short)6144);
      sheet.setColumnWidth((short)1, (short)3072);
      sheet.setColumnWidth((short)2, (short)6144);
      sheet.setColumnWidth((short)3, (short)8192);
      sheet.setColumnWidth((short)4, (short)4096);
      sheet.setColumnWidth((short)5, (short)2560);
      sheet.setColumnWidth((short)6, (short)4608);
      sheet.setColumnWidth((short)7, (short)4608);
      sheet.setColumnWidth((short)8, (short)3072);
      sheet.setColumnWidth((short)9, (short)7168);
      sheet.setColumnWidth((short)10, (short)3072);
      sheet.setColumnWidth((short)11, (short)3072);
      sheet.setColumnWidth((short)12, (short)3072);
      sheet.setColumnWidth((short)13, (short)2560);
      sheet.setColumnWidth((short)14, (short)2560);
      sheet.setColumnWidth((short)15, (short)5120);
      sheet.setColumnWidth((short)16, (short)2560);
      sheet.setColumnWidth((short)17, (short)7168);
      sheet.setColumnWidth((short)18, (short)2560);
      sheet.setColumnWidth((short)19, (short)3072);
      sheet.setColumnWidth((short)20, (short)4608);
      sheet.setColumnWidth((short)21, (short)8192);
      sheet.setColumnWidth((short)22, (short)8192);
      sheet.setColumnWidth((short)23, (short)4096);
      sheet.setColumnWidth((short)24, (short)5120);
      sheet.setColumnWidth((short)25, (short)4096);
      sheet.setColumnWidth((short)26, (short)3072);
      sheet.setColumnWidth((short)27, (short)6144);
      sheet.setColumnWidth((short)29, (short)5120);
      sheet.setColumnWidth((short)32, (short)4096);
      sheet.setColumnWidth((short)33, (short)3072);
      sheet.setColumnWidth((short)34, (short)4096);
      sheet.setColumnWidth((short)35, (short)7168);
      sheet.setColumnWidth((short)37, (short)6144);
      sheet.setColumnWidth((short)38, (short)10240);
      sheet.setColumnWidth((short)39, (short)5120);
      sheet.setColumnWidth((short)40, (short)7680);
      sheet.setColumnWidth((short)42, (short)4608);
      sheet.setColumnWidth((short)44, (short)4096);
      sheet.setColumnWidth((short)46, (short)4608);
      sheet.setColumnWidth((short)48, (short)4096);
      sheet.setColumnWidth((short)49, (short)7168);
      sheet.setColumnWidth((short)51, (short)6144);
      sheet.setColumnWidth((short)52, (short)7680);
      sheet.setColumnWidth((short)54, (short)4096);
      sheet.setColumnWidth((short)55, (short)7168);
      sheet.setColumnWidth((short)56, (short)6144);
      workbook.setSheetName(0, "项目跟踪信息统计表", (short)1);
      HSSFCellStyle borderStyle = workbook.createCellStyle();
      HSSFCellStyle style00 = workbook.createCellStyle();
      HSSFFont colFont00 = workbook.createFont();
      colFont00.setFontHeightInPoints((short)18);
      colFont00.setFontName("宋体");
      colFont00.setBoldweight((short)700);
      style00.setAlignment((short)2);
      style00.setVerticalAlignment((short)1);
      style00.setFont(colFont00);
      style00.setBorderTop((short)1);
      style00.setBorderRight((short)1);
      style00.setBorderBottom((short)1);
      style00.setBorderLeft((short)1);
      HSSFRow row0 = sheet.createRow(0);
      row0.setHeight((short)850);
      HSSFCell cell00 = row0.createCell((short)0);
      cell00.setEncoding((short)1);
      cell00.setCellStyle(style00);
      String date = StringUtils.getDate();
      cell00.setCellValue("梦天门销售商机管理表（导出日期：" + date.substring(0, 4) + "年" + date.substring(5, 7) + "月" + date
          .substring(8, 10) + "日 ）");
      for (int i = 1; i < 59; i++) {
        cell00 = row0.createCell((short)i);
        cell00.setEncoding((short)1);
        cell00.setCellStyle(style00);
        cell00.setCellValue("");
      } 
      Region regionDate = new Region(0, (short)0, 0, (short)27);
      sheet.addMergedRegion(regionDate);
      HSSFCellStyle style10 = workbook.createCellStyle();
      HSSFFont colFont10 = workbook.createFont();
      colFont10.setFontName("宋体");
      colFont10.setFontHeightInPoints((short)11);
      colFont10.setBoldweight((short)700);
      style10.setAlignment((short)2);
      style10.setVerticalAlignment((short)1);
      style10.setFont(colFont10);
      style10.setBorderTop((short)1);
      style10.setBorderRight((short)1);
      style10.setBorderBottom((short)1);
      style10.setBorderLeft((short)1);
      HSSFCellStyle styleYellow = workbook.createCellStyle();
      styleYellow.setAlignment((short)2);
      styleYellow.setVerticalAlignment((short)1);
      styleYellow.setFont(colFont10);
      styleYellow.setBorderTop((short)1);
      styleYellow.setBorderRight((short)1);
      styleYellow.setBorderBottom((short)1);
      styleYellow.setBorderLeft((short)1);
      styleYellow.setFillForegroundColor((short)13);
      styleYellow.setFillPattern((short)1);
      HSSFCellStyle styleGreen = workbook.createCellStyle();
      styleGreen.setAlignment((short)2);
      styleGreen.setVerticalAlignment((short)1);
      styleGreen.setFont(colFont10);
      styleGreen.setBorderTop((short)1);
      styleGreen.setBorderRight((short)1);
      styleGreen.setBorderBottom((short)1);
      styleGreen.setBorderLeft((short)1);
      styleGreen.setFillForegroundColor((short)11);
      styleGreen.setFillPattern((short)1);
      HSSFCellStyle styleBlue = workbook.createCellStyle();
      styleBlue.setAlignment((short)2);
      styleBlue.setVerticalAlignment((short)1);
      styleBlue.setFont(colFont10);
      styleBlue.setBorderTop((short)1);
      styleBlue.setBorderRight((short)1);
      styleBlue.setBorderBottom((short)1);
      styleBlue.setBorderLeft((short)1);
      styleBlue.setFillForegroundColor((short)48);
      styleBlue.setFillPattern((short)1);
      HSSFRow row1 = sheet.createRow(1);
      row1.setHeight((short)850);
      HSSFCell cell1 = row1.createCell((short)0);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机编号");
      cell1 = row1.createCell((short)1);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("业务类别");
      cell1 = row1.createCell((short)2);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机名称");
      cell1 = row1.createCell((short)3);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机简述");
      cell1 = row1.createCell((short)4);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("资金来源");
      cell1 = row1.createCell((short)5);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("重大商机");
      cell1 = row1.createCell((short)6);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("整体预算(元)");
      cell1 = row1.createCell((short)7);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机预算(元)");
      cell1 = row1.createCell((short)8);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机类型");
      cell1 = row1.createCell((short)9);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("客户名称");
      cell1 = row1.createCell((short)10);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("省份");
      cell1 = row1.createCell((short)11);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("地市");
      cell1 = row1.createCell((short)12);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("区县");
      cell1 = row1.createCell((short)13);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("销售员");
      cell1 = row1.createCell((short)14);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("售前人员");
      cell1 = row1.createCell((short)15);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("销售部门");
      cell1 = row1.createCell((short)16);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("代理商是否参与");
      cell1 = row1.createCell((short)17);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("代理商全称");
      cell1 = row1.createCell((short)18);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机进度");
      cell1 = row1.createCell((short)19);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("商机阶段");
      cell1 = row1.createCell((short)20);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("预计签订日期");
      cell1 = row1.createCell((short)21);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("建设内容");
      cell1 = row1.createCell((short)22);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("竞争对手分析");
      cell1 = row1.createCell((short)23);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("客户联系人");
      cell1 = row1.createCell((short)24);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("联系方式");
      cell1 = row1.createCell((short)25);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("立项日期");
      cell1 = row1.createCell((short)26);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("操作人");
      cell1 = row1.createCell((short)27);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(style10);
      cell1.setCellValue("更新时间");
      cell1 = row1.createCell((short)28);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(styleYellow);
      cell1.setCellValue("售前阶段");
      int k;
      for (k = 29; k < 37; k++) {
        cell1 = row1.createCell((short)k);
        cell1.setEncoding((short)1);
        cell1.setCellStyle(styleYellow);
        cell1.setCellValue("");
      } 
      cell1 = row1.createCell((short)38);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(styleGreen);
      cell1.setCellValue("签订与执行阶段");
      for (k = 39; k < 52; k++) {
        cell1 = row1.createCell((short)k);
        cell1.setEncoding((short)1);
        cell1.setCellStyle(styleGreen);
        cell1.setCellValue("");
      } 
      cell1 = row1.createCell((short)53);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(styleBlue);
      cell1.setCellValue("运维阶段");
      for (k = 54; k < 58; k++) {
        cell1 = row1.createCell((short)k);
        cell1.setEncoding((short)1);
        cell1.setCellStyle(styleBlue);
        cell1.setCellValue("");
      } 
      cell1 = row1.createCell((short)58);
      cell1.setEncoding((short)1);
      cell1.setCellStyle(styleBlue);
      cell1.setCellValue("");
      HSSFCellStyle style20 = workbook.createCellStyle();
      HSSFFont colFont20 = workbook.createFont();
      colFont20.setFontName("宋体");
      colFont20.setFontHeightInPoints((short)11);
      colFont20.setBoldweight((short)700);
      style20.setAlignment((short)2);
      style20.setVerticalAlignment((short)1);
      style20.setFont(colFont20);
      style20.setBorderTop((short)1);
      style20.setBorderRight((short)1);
      style20.setBorderBottom((short)1);
      style20.setBorderLeft((short)1);
      HSSFCellStyle style20Yellow = workbook.createCellStyle();
      style20Yellow.setAlignment((short)2);
      style20Yellow.setVerticalAlignment((short)1);
      style20Yellow.setFont(colFont20);
      style20Yellow.setBorderTop((short)1);
      style20Yellow.setBorderRight((short)1);
      style20Yellow.setBorderBottom((short)1);
      style20Yellow.setBorderLeft((short)1);
      style20Yellow.setFillForegroundColor((short)13);
      style20Yellow.setFillPattern((short)1);
      HSSFCellStyle style20Green = workbook.createCellStyle();
      style20Green.setAlignment((short)2);
      style20Green.setVerticalAlignment((short)1);
      style20Green.setFont(colFont20);
      style20Green.setBorderTop((short)1);
      style20Green.setBorderRight((short)1);
      style20Green.setBorderBottom((short)1);
      style20Green.setBorderLeft((short)1);
      style20Green.setFillForegroundColor((short)11);
      style20Green.setFillPattern((short)1);
      HSSFCellStyle style20Blue = workbook.createCellStyle();
      style20Blue.setAlignment((short)2);
      style20Blue.setVerticalAlignment((short)1);
      style20Blue.setFont(colFont20);
      style20Blue.setBorderTop((short)1);
      style20Blue.setBorderRight((short)1);
      style20Blue.setBorderBottom((short)1);
      style20Blue.setBorderLeft((short)1);
      style20Blue.setFillForegroundColor((short)48);
      style20Blue.setFillPattern((short)1);
      HSSFRow row2 = sheet.createRow(2);
      row2.setHeight((short)300);
      HSSFCell cell2 = null;
      for (int m = 0; m < 28; m++) {
        cell2 = row2.createCell((short)m);
        cell2.setEncoding((short)1);
        cell2.setCellStyle(style20);
        cell2.setCellValue("");
      } 
      cell2 = row2.createCell((short)28);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("跟踪结论");
      cell2 = row2.createCell((short)29);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("项目阶段");
      cell2 = row2.createCell((short)30);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("把握度");
      cell2 = row2.createCell((short)31);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("重要性");
      cell2 = row2.createCell((short)32);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("投标日期");
      cell2 = row2.createCell((short)33);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("联系人");
      cell2 = row2.createCell((short)34);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("联系人电话");
      cell2 = row2.createCell((short)35);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("备注说明");
      cell2 = row2.createCell((short)36);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("录入人员");
      cell2 = row2.createCell((short)37);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Yellow);
      cell2.setCellValue("录入时间");
      cell2 = row2.createCell((short)38);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("合同名称");
      cell2 = row2.createCell((short)39);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("项目编号");
      cell2 = row2.createCell((short)40);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("项目阶段");
      cell2 = row2.createCell((short)41);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("合同时限");
      cell2 = row2.createCell((short)42);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("投标保证金");
      cell2 = row2.createCell((short)43);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("保证金金额（元）");
      cell2 = row2.createCell((short)44);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("中标通知书");
      cell2 = row2.createCell((short)45);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("未结金额（元）");
      cell2 = row2.createCell((short)46);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("履约保证金");
      cell2 = row2.createCell((short)47);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("履约金金额（元）");
      cell2 = row2.createCell((short)48);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("联系人");
      cell2 = row2.createCell((short)49);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("联系人电话");
      cell2 = row2.createCell((short)50);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("备注说明");
      cell2 = row2.createCell((short)51);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("录入人");
      cell2 = row2.createCell((short)52);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Green);
      cell2.setCellValue("录入时间");
      cell2 = row2.createCell((short)53);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("运维时间");
      cell2 = row2.createCell((short)54);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("联系人");
      cell2 = row2.createCell((short)55);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("联系人电话");
      cell2 = row2.createCell((short)56);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("备注说明");
      cell2 = row2.createCell((short)57);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("录入人");
      cell2 = row2.createCell((short)58);
      cell2.setEncoding((short)1);
      cell2.setCellStyle(style20Blue);
      cell2.setCellValue("录入时间");
      sheet.addMergedRegion(new Region(1, (short)0, 2, (short)0));
      sheet.addMergedRegion(new Region(1, (short)1, 2, (short)1));
      sheet.addMergedRegion(new Region(1, (short)2, 2, (short)2));
      sheet.addMergedRegion(new Region(1, (short)3, 2, (short)3));
      sheet.addMergedRegion(new Region(1, (short)4, 2, (short)4));
      sheet.addMergedRegion(new Region(1, (short)5, 2, (short)5));
      sheet.addMergedRegion(new Region(1, (short)6, 2, (short)6));
      sheet.addMergedRegion(new Region(1, (short)7, 2, (short)7));
      sheet.addMergedRegion(new Region(1, (short)8, 2, (short)8));
      sheet.addMergedRegion(new Region(1, (short)9, 2, (short)9));
      sheet.addMergedRegion(new Region(1, (short)10, 2, (short)10));
      sheet.addMergedRegion(new Region(1, (short)11, 2, (short)11));
      sheet.addMergedRegion(new Region(1, (short)12, 2, (short)12));
      sheet.addMergedRegion(new Region(1, (short)13, 2, (short)13));
      sheet.addMergedRegion(new Region(1, (short)14, 2, (short)14));
      sheet.addMergedRegion(new Region(1, (short)15, 2, (short)15));
      sheet.addMergedRegion(new Region(1, (short)16, 2, (short)16));
      sheet.addMergedRegion(new Region(1, (short)17, 2, (short)17));
      sheet.addMergedRegion(new Region(1, (short)18, 2, (short)18));
      sheet.addMergedRegion(new Region(1, (short)19, 2, (short)19));
      sheet.addMergedRegion(new Region(1, (short)20, 2, (short)20));
      sheet.addMergedRegion(new Region(1, (short)21, 2, (short)21));
      sheet.addMergedRegion(new Region(1, (short)22, 2, (short)22));
      sheet.addMergedRegion(new Region(1, (short)23, 2, (short)23));
      sheet.addMergedRegion(new Region(1, (short)24, 2, (short)24));
      sheet.addMergedRegion(new Region(1, (short)25, 2, (short)25));
      sheet.addMergedRegion(new Region(1, (short)26, 2, (short)26));
      sheet.addMergedRegion(new Region(1, (short)27, 2, (short)27));
      sheet.addMergedRegion(new Region(1, (short)28, 1, (short)37));
      sheet.addMergedRegion(new Region(1, (short)38, 1, (short)52));
      sheet.addMergedRegion(new Region(1, (short)53, 1, (short)58));
      HSSFCellStyle styleSimple = workbook.createCellStyle();
      HSSFFont colFontSimple = workbook.createFont();
      colFontSimple.setFontName("宋体");
      colFontSimple.setFontHeightInPoints((short)11);
      styleSimple.setAlignment((short)2);
      styleSimple.setVerticalAlignment((short)1);
      styleSimple.setFont(colFontSimple);
      styleSimple.setBorderTop((short)1);
      styleSimple.setBorderRight((short)1);
      styleSimple.setBorderBottom((short)1);
      styleSimple.setBorderLeft((short)1);
      HSSFCellStyle styleSimpleColor = workbook.createCellStyle();
      HSSFFont colFontSimpleColor = workbook.createFont();
      colFontSimpleColor.setFontName("宋体");
      colFontSimpleColor.setFontHeightInPoints((short)11);
      styleSimpleColor.setAlignment((short)2);
      styleSimpleColor.setVerticalAlignment((short)1);
      styleSimpleColor.setFont(colFontSimple);
      styleSimpleColor.setBorderTop((short)1);
      styleSimpleColor.setBorderRight((short)1);
      styleSimpleColor.setBorderBottom((short)1);
      styleSimpleColor.setBorderLeft((short)1);
      styleSimpleColor.setFillForegroundColor((short)22);
      styleSimpleColor.setFillPattern((short)1);
      HSSFCellStyle styleSimpleLeft = workbook.createCellStyle();
      HSSFFont colFontSimpleLeft = workbook.createFont();
      colFontSimpleLeft.setFontName("宋体");
      colFontSimpleLeft.setFontHeightInPoints((short)11);
      styleSimpleLeft.setAlignment((short)1);
      styleSimpleLeft.setVerticalAlignment((short)1);
      styleSimpleLeft.setFont(colFontSimpleLeft);
      styleSimpleLeft.setBorderTop((short)1);
      styleSimpleLeft.setBorderRight((short)1);
      styleSimpleLeft.setBorderBottom((short)1);
      styleSimpleLeft.setBorderLeft((short)1);
      HSSFCellStyle styleSimpleLeftColor = workbook.createCellStyle();
      HSSFFont colFontSimpleLeftColor = workbook.createFont();
      colFontSimpleLeftColor.setFontName("宋体");
      colFontSimpleLeftColor.setFontHeightInPoints((short)11);
      styleSimpleLeftColor.setAlignment((short)1);
      styleSimpleLeftColor.setVerticalAlignment((short)1);
      styleSimpleLeftColor.setFont(colFontSimpleLeftColor);
      styleSimpleLeftColor.setBorderTop((short)1);
      styleSimpleLeftColor.setBorderRight((short)1);
      styleSimpleLeftColor.setBorderBottom((short)1);
      styleSimpleLeftColor.setBorderLeft((short)1);
      styleSimpleLeftColor.setFillForegroundColor((short)22);
      styleSimpleLeftColor.setFillPattern((short)1);
      HSSFCellStyle styleSimpleYellow = workbook.createCellStyle();
      styleSimpleYellow.setAlignment((short)2);
      styleSimpleYellow.setVerticalAlignment((short)1);
      styleSimpleYellow.setFont(colFontSimple);
      styleSimpleYellow.setBorderTop((short)1);
      styleSimpleYellow.setBorderRight((short)1);
      styleSimpleYellow.setBorderBottom((short)1);
      styleSimpleYellow.setBorderLeft((short)1);
      styleSimpleYellow.setFillForegroundColor((short)13);
      styleSimpleYellow.setFillPattern((short)1);
      HSSFCellStyle styleSimpleGreen = workbook.createCellStyle();
      styleSimpleGreen.setAlignment((short)2);
      styleSimpleGreen.setVerticalAlignment((short)1);
      styleSimpleGreen.setFont(colFontSimple);
      styleSimpleGreen.setBorderTop((short)1);
      styleSimpleGreen.setBorderRight((short)1);
      styleSimpleGreen.setBorderBottom((short)1);
      styleSimpleGreen.setBorderLeft((short)1);
      styleSimpleGreen.setFillForegroundColor((short)11);
      styleSimpleGreen.setFillPattern((short)1);
      HSSFCellStyle styleSimpleBlue = workbook.createCellStyle();
      styleSimpleBlue.setAlignment((short)2);
      styleSimpleBlue.setVerticalAlignment((short)1);
      styleSimpleBlue.setFont(colFontSimple);
      styleSimpleBlue.setBorderTop((short)1);
      styleSimpleBlue.setBorderRight((short)1);
      styleSimpleBlue.setBorderBottom((short)1);
      styleSimpleBlue.setBorderLeft((short)1);
      styleSimpleBlue.setFillForegroundColor((short)48);
      styleSimpleBlue.setFillPattern((short)1);
      HSSFCellStyle styleSimpleYellowLeft = workbook.createCellStyle();
      styleSimpleYellowLeft.setAlignment((short)2);
      styleSimpleYellowLeft.setVerticalAlignment((short)1);
      styleSimpleYellowLeft.setFont(colFontSimpleLeft);
      styleSimpleYellowLeft.setBorderTop((short)1);
      styleSimpleYellowLeft.setBorderRight((short)1);
      styleSimpleYellowLeft.setBorderBottom((short)1);
      styleSimpleYellowLeft.setBorderLeft((short)1);
      styleSimpleYellowLeft.setFillForegroundColor((short)13);
      styleSimpleYellowLeft.setFillPattern((short)1);
      HSSFCellStyle styleSimpleGreenLeft = workbook.createCellStyle();
      styleSimpleGreenLeft.setAlignment((short)2);
      styleSimpleGreenLeft.setVerticalAlignment((short)1);
      styleSimpleGreenLeft.setFont(colFontSimpleLeft);
      styleSimpleGreenLeft.setBorderTop((short)1);
      styleSimpleGreenLeft.setBorderRight((short)1);
      styleSimpleGreenLeft.setBorderBottom((short)1);
      styleSimpleGreenLeft.setBorderLeft((short)1);
      styleSimpleGreenLeft.setFillForegroundColor((short)11);
      styleSimpleGreenLeft.setFillPattern((short)1);
      HSSFCellStyle styleSimpleBlueLeft = workbook.createCellStyle();
      styleSimpleBlueLeft.setAlignment((short)2);
      styleSimpleBlueLeft.setVerticalAlignment((short)1);
      styleSimpleBlueLeft.setFont(colFontSimpleLeft);
      styleSimpleBlueLeft.setBorderTop((short)1);
      styleSimpleBlueLeft.setBorderRight((short)1);
      styleSimpleBlueLeft.setBorderBottom((short)1);
      styleSimpleBlueLeft.setBorderLeft((short)1);
      styleSimpleBlueLeft.setFillForegroundColor((short)48);
      styleSimpleBlueLeft.setFillPattern((short)1);
      if (scxmList != null && scxmList.size() > 0)
        for (int n = 0; n < scxmList.size(); n++) {
          Scxm scxm = scxmList.get(n);
          for (int i1 = 0; i1 < 3; i1++) {
            HSSFRow hSSFRow = sheet.createRow((short)(n * 3 + i1 + 3));
            hSSFRow.setHeight((short)300);
            if (i1 == 0) {
              HSSFCell hSSFCell = hSSFRow.createCell((short)0);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getBusinessOpportunityCode());
              hSSFCell = hSSFRow.createCell((short)1);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(getbusinessTypeName(scxm.getBusinessType()));
              hSSFCell = hSSFRow.createCell((short)2);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue((scxm.getXmmc() == null) ? "" : scxm.getXmmc());
              hSSFCell = hSSFRow.createCell((short)3);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue((scxm.getBz() == null) ? "" : scxm.getBz());
              hSSFCell = hSSFRow.createCell((short)4);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(getFundSource(scxm.getFundSource()));
              hSSFCell = hSSFRow.createCell((short)5);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("1".equals(scxm.getIsGreat()) ? "是" : "否");
              hSSFCell = hSSFRow.createCell((short)6);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              if (scxm.getWholeBudget() != null && !"".equals(scxm.getWholeBudget()))
                hSSFCell.setCellValue(
                    StringUtils.formatMoney(String.valueOf(Double.valueOf(scxm.getWholeBudget()).doubleValue() * 10000.0D), 2)); 
              hSSFCell = hSSFRow.createCell((short)7);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              if (scxm.getYsje() != null && !"".equals(scxm.getYsje()))
                hSSFCell.setCellValue(
                    StringUtils.formatMoney(String.valueOf(Double.valueOf(scxm.getYsje()).doubleValue() * 10000.0D), 2)); 
              if (!"".equals(scxm.getYsje()) && scxm.getYsje() != null) {
                ysjeSum = ysjeSum.add(new BigDecimal(scxm.getYsje()));
                yzbSum = yzbSum.add(new BigDecimal((scxm.getZbje() == null) ? "0" : scxm.getZbje()));
              } 
              hSSFCell = hSSFRow.createCell((short)8);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(getBusinessOpportunityType(scxm.getBusinessOpportunityType()));
              hSSFCell = hSSFRow.createCell((short)9);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getJsdw());
              hSSFCell = hSSFRow.createCell((short)10);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getBuspName());
              hSSFCell = hSSFRow.createCell((short)11);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getBuscName());
              hSSFCell = hSSFRow.createCell((short)12);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getBusdName());
              hSSFCell = hSSFRow.createCell((short)13);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getSalesPersonName());
              hSSFCell = hSSFRow.createCell((short)14);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getPreSalesPersonName());
              hSSFCell = hSSFRow.createCell((short)15);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getCjrDeptName());
              hSSFCell = hSSFRow.createCell((short)16);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("1".equals(scxm.getHasAgent()) ? "是" : "否");
              hSSFCell = hSSFRow.createCell((short)17);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getAgentName());
              hSSFCell = hSSFRow.createCell((short)18);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getProjectRate());
              hSSFCell = hSSFRow.createCell((short)19);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(getBusinessStage(scxm.getBusinessStage()));
              hSSFCell = hSSFRow.createCell((short)20);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getPlanSignDate());
              hSSFCell = hSSFRow.createCell((short)21);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue(scxm.getProjectContent());
              hSSFCell = hSSFRow.createCell((short)22);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getCompetitorAnalysis());
              hSSFCell = hSSFRow.createCell((short)23);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getLxr());
              hSSFCell = hSSFRow.createCell((short)24);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getLxdh());
              hSSFCell = hSSFRow.createCell((short)25);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getProjectEstablishmentDate());
              hSSFCell = hSSFRow.createCell((short)26);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getCjr());
              hSSFCell = hSSFRow.createCell((short)27);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue(scxm.getUpdateTime());
            } else {
              HSSFCell hSSFCell = hSSFRow.createCell((short)0);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)1);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)2);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)3);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)4);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)5);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)6);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)7);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)8);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)9);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)10);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)11);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)12);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)13);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)14);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)15);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)16);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)17);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)18);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)19);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)20);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)21);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleLeftColor : styleSimpleLeft);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)22);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)23);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)24);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)25);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)26);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
              hSSFCell = hSSFRow.createCell((short)27);
              hSSFCell.setEncoding((short)1);
              hSSFCell.setCellStyle((n % 2 == 0) ? styleSimpleColor : styleSimple);
              hSSFCell.setCellValue("");
            } 
            HSSFCell cellOne = null;
            boolean sqFlag = false;
            if (sqList != null && sqList.size() > 0)
              for (int j2 = 0; j2 < sqList.size(); j2++) {
                ScxmSq sq = sqList.get(j2);
                if (sq.getScxmID().equals(scxm.getId())) {
                  sqFlag = true;
                  cellOne = hSSFRow.createCell((short)28);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(getGzjlName(sq.getJn()));
                  cellOne = hSSFRow.createCell((short)29);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(getSqXmjdName(sq.getJd()));
                  cellOne = hSSFRow.createCell((short)30);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(getBwdName(sq.getBwd()));
                  cellOne = hSSFRow.createCell((short)31);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(getZyxName(sq.getZyx()));
                  cellOne = hSSFRow.createCell((short)32);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(sq.getTbrq());
                  cellOne = hSSFRow.createCell((short)33);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(sq.getLxr());
                  cellOne = hSSFRow.createCell((short)34);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(sq.getLxrdh());
                  cellOne = hSSFRow.createCell((short)35);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellowLeft);
                  cellOne.setCellValue(sq.getBz());
                  cellOne = hSSFRow.createCell((short)36);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(sq.getCjr());
                  cellOne = hSSFRow.createCell((short)37);
                  cellOne.setEncoding((short)1);
                  cellOne.setCellStyle(styleSimpleYellow);
                  cellOne.setCellValue(sq.getCreateTime());
                  sqList.remove(j2);
                  break;
                } 
              }  
            if (!sqFlag) {
              cellOne = hSSFRow.createCell((short)28);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)29);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)30);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)31);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)32);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)33);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)34);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)35);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)36);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
              cellOne = hSSFRow.createCell((short)37);
              cellOne.setEncoding((short)1);
              cellOne.setCellStyle(styleSimpleYellow);
              cellOne.setCellValue("");
            } 
            HSSFCell cellTwo = null;
            boolean qdzxFlag = false;
            if (qdzxList != null && qdzxList.size() > 0)
              for (int j2 = 0; j2 < qdzxList.size(); j2++) {
                ScxmQdzx qdzx = qdzxList.get(j2);
                if (qdzx.getScxmID().equals(scxm.getId())) {
                  qdzxFlag = true;
                  cellTwo = hSSFRow.createCell((short)38);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreenLeft);
                  cellTwo.setCellValue(qdzx.getHtmc());
                  cellTwo = hSSFRow.createCell((short)39);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(qdzx.getXmbh());
                  cellTwo = hSSFRow.createCell((short)40);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(getQdzxJdName(qdzx.getJd()));
                  cellTwo = hSSFRow.createCell((short)41);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(((qdzx.getHtkssj() == null) ? "" : qdzx.getHtkssj()) + " 至 " + (
                      (qdzx.getHtjssj() == null) ? "" : qdzx.getHtjssj()));
                  cellTwo = hSSFRow.createCell((short)42);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(getQdzxBzjztName(qdzx.getTbbzjzt()));
                  cellTwo = hSSFRow.createCell((short)43);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  if (qdzx.getTbbzjje() != null && !"".equals(qdzx.getTbbzjje()))
                    cellTwo.setCellValue(
                        StringUtils.formatMoney(String.valueOf(qdzx.getTbbzjje()), 2)); 
                  if (!"".equals(qdzx.getTbbzjje()) && qdzx.getTbbzjje() != null)
                    tbbzjSum = tbbzjSum.add(new BigDecimal(qdzx.getTbbzjje())); 
                  cellTwo = hSSFRow.createCell((short)44);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(getQdzxZbtzsName(qdzx.getZbtzs()));
                  cellTwo = hSSFRow.createCell((short)45);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  if (qdzx.getWjje() != null && !"".equals(qdzx.getWjje()))
                    cellTwo.setCellValue(
                        StringUtils.formatMoney(String.valueOf(qdzx.getWjje()), 2)); 
                  if (!"".equals(qdzx.getWjje()) && qdzx.getWjje() != null)
                    wjjeSum = wjjeSum.add(new BigDecimal(qdzx.getWjje())); 
                  cellTwo = hSSFRow.createCell((short)46);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(getQdzxLybzjztName(qdzx.getLybzjzt()));
                  cellTwo = hSSFRow.createCell((short)47);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  if (qdzx.getLybzjje() != null && !"".equals(qdzx.getLybzjje()))
                    cellTwo.setCellValue(
                        StringUtils.formatMoney(String.valueOf(qdzx.getLybzjje()), 2)); 
                  if (!"".equals(qdzx.getLybzjje()) && qdzx.getLybzjje() != null)
                    lyjjeSum = lyjjeSum.add(new BigDecimal(qdzx.getLybzjje())); 
                  cellTwo = hSSFRow.createCell((short)48);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(qdzx.getLxr());
                  cellTwo = hSSFRow.createCell((short)49);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(qdzx.getLxrdh());
                  cellTwo = hSSFRow.createCell((short)50);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreenLeft);
                  cellTwo.setCellValue(qdzx.getBz());
                  cellTwo = hSSFRow.createCell((short)51);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(qdzx.getCjr());
                  cellTwo = hSSFRow.createCell((short)52);
                  cellTwo.setEncoding((short)1);
                  cellTwo.setCellStyle(styleSimpleGreen);
                  cellTwo.setCellValue(qdzx.getCreateTime());
                  qdzxList.remove(j2);
                  break;
                } 
              }  
            if (!qdzxFlag) {
              cellTwo = hSSFRow.createCell((short)38);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreenLeft);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)39);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)40);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)41);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)42);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)43);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)44);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)45);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)46);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)47);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)48);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)49);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)50);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)51);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
              cellTwo = hSSFRow.createCell((short)52);
              cellTwo.setEncoding((short)1);
              cellTwo.setCellStyle(styleSimpleGreen);
              cellTwo.setCellValue("");
            } 
            HSSFCell cellThree = null;
            boolean ywFlag = false;
            if (ywList != null && ywList.size() > 0)
              for (int j2 = 0; j2 < ywList.size(); j2++) {
                ScxmYw yw = ywList.get(j2);
                if (yw.getScxmID().equals(scxm.getId())) {
                  ywFlag = true;
                  cellThree = hSSFRow.createCell((short)53);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlue);
                  cellThree.setCellValue(((yw.getYwkssj() == null) ? "" : yw.getYwkssj()) + " 至 " + (
                      (yw.getYwjssj() == null) ? "" : yw.getYwjssj()));
                  cellThree = hSSFRow.createCell((short)54);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlue);
                  cellThree.setCellValue(yw.getLxr());
                  cellThree = hSSFRow.createCell((short)55);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlue);
                  cellThree.setCellValue(yw.getLxrdh());
                  cellThree = hSSFRow.createCell((short)56);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlueLeft);
                  cellThree.setCellValue(yw.getBz());
                  cellThree = hSSFRow.createCell((short)57);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlue);
                  cellThree.setCellValue(yw.getCjr());
                  cellThree = hSSFRow.createCell((short)58);
                  cellThree.setEncoding((short)1);
                  cellThree.setCellStyle(styleSimpleBlue);
                  cellThree.setCellValue(yw.getCreateTime());
                  ywList.remove(j2);
                  break;
                } 
              }  
            if (!ywFlag) {
              cellThree = hSSFRow.createCell((short)53);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlue);
              cellThree.setCellValue("");
              cellThree = hSSFRow.createCell((short)54);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlue);
              cellThree.setCellValue("");
              cellThree = hSSFRow.createCell((short)55);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlue);
              cellThree.setCellValue("");
              cellThree = hSSFRow.createCell((short)56);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlueLeft);
              cellThree.setCellValue("");
              cellThree = hSSFRow.createCell((short)57);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlue);
              cellThree.setCellValue("");
              cellThree = hSSFRow.createCell((short)58);
              cellThree.setEncoding((short)1);
              cellThree.setCellStyle(styleSimpleBlue);
              cellThree.setCellValue("");
            } 
          } 
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)0, (short)(n * 3 + 5), (short)0));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)1, (short)(n * 3 + 5), (short)1));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)2, (short)(n * 3 + 5), (short)2));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)3, (short)(n * 3 + 5), (short)3));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)4, (short)(n * 3 + 5), (short)4));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)5, (short)(n * 3 + 5), (short)5));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)6, (short)(n * 3 + 5), (short)6));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)7, (short)(n * 3 + 5), (short)7));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)8, (short)(n * 3 + 5), (short)8));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)9, (short)(n * 3 + 5), (short)9));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)10, (short)(n * 3 + 5), (short)10));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)11, (short)(n * 3 + 5), (short)11));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)12, (short)(n * 3 + 5), (short)12));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)13, (short)(n * 3 + 5), (short)13));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)14, (short)(n * 3 + 5), (short)14));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)15, (short)(n * 3 + 5), (short)15));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)16, (short)(n * 3 + 5), (short)16));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)17, (short)(n * 3 + 5), (short)17));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)18, (short)(n * 3 + 5), (short)18));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)19, (short)(n * 3 + 5), (short)19));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)20, (short)(n * 3 + 5), (short)20));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)21, (short)(n * 3 + 5), (short)21));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)22, (short)(n * 3 + 5), (short)22));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)23, (short)(n * 3 + 5), (short)23));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)24, (short)(n * 3 + 5), (short)24));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)25, (short)(n * 3 + 5), (short)25));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)26, (short)(n * 3 + 5), (short)26));
          sheet.addMergedRegion(new Region((short)(n * 3 + 3), (short)27, (short)(n * 3 + 5), (short)27));
        }  
      HSSFCellStyle hjStyle = workbook.createCellStyle();
      HSSFFont hjFont = workbook.createFont();
      hjFont.setFontName("宋体");
      hjFont.setFontHeightInPoints((short)11);
      hjFont.setColor((short)10);
      hjFont.setBoldweight((short)700);
      hjStyle.setAlignment((short)2);
      hjStyle.setVerticalAlignment((short)1);
      hjStyle.setFont(hjFont);
      hjStyle.setBorderTop((short)1);
      hjStyle.setBorderRight((short)1);
      hjStyle.setBorderBottom((short)1);
      hjStyle.setBorderLeft((short)1);
      HSSFCellStyle hjStyleLeft = workbook.createCellStyle();
      hjFont.setBoldweight((short)700);
      hjStyleLeft.setAlignment((short)1);
      hjStyleLeft.setVerticalAlignment((short)1);
      hjStyleLeft.setFont(hjFont);
      hjStyleLeft.setBorderTop((short)1);
      hjStyleLeft.setBorderRight((short)1);
      hjStyleLeft.setBorderBottom((short)1);
      hjStyleLeft.setBorderLeft((short)1);
      HSSFRow row = sheet.createRow((short)(scxmList.size() * 3 + 3));
      row.setHeight((short)500);
      HSSFCell cell = row.createCell((short)0);
      cell.setEncoding((short)1);
      cell.setCellStyle(hjStyle);
      cell.setCellValue("合计");
      cell = row.createCell((short)1);
      cell.setEncoding((short)1);
      cell.setCellStyle(hjStyleLeft);
      cell.setCellValue("  商机总金额： " + StringUtils.formatMoney(String.valueOf(ysjeSum.doubleValue() * 10000.0D), 2) + "元　已中标总金额： " + 
          StringUtils.formatMoney(String.valueOf(yzbSum.doubleValue() * 10000.0D), 2) + "元");
      for (int j = 2; j < 59; j++) {
        cell = row.createCell((short)j);
        cell.setEncoding((short)1);
        cell.setCellStyle(hjStyleLeft);
        cell.setCellValue("");
      } 
      sheet.addMergedRegion(new Region((short)(scxmList.size() * 3 + 3), (short)1, 
            (short)(scxmList.size() * 3 + 3), (short)58));
      response.addHeader("content-disposition", "attachment;filename=" + 
          URLEncoder.encode(fileName.substring(fileName.lastIndexOf("/") + 1), "utf-8"));
      OutputStream fOut = new BufferedOutputStream((OutputStream)response.getOutputStream());
      response.setContentType("application/vnd.ms-excel;charset=utf-8");
      workbook.write(fOut);
      fOut.flush();
      fOut.close();
    } catch (Exception e) {
      e.printStackTrace();
      log.error(e);
    } finally {
      HibernateUtil.closeSession();
    } 
    return null;
  }
  
  public String getBusinessStage(String businessStage) {
    String name = "";
    if ("01".equals(businessStage)) {
      name = "初次拜访";
    } else if ("02".equals(businessStage)) {
      name = "方案交流";
    } else if ("03".equals(businessStage)) {
      name = "产品演示";
    } else if ("04".equals(businessStage)) {
      name = "产品试用";
    } else if ("05".equals(businessStage)) {
      name = "产品培训";
    } else if ("06".equals(businessStage)) {
      name = "建设方案准备";
    } else if ("07".equals(businessStage)) {
      name = "项目申报";
    } else if ("08".equals(businessStage)) {
      name = "商务洽谈";
    } else if ("09".equals(businessStage)) {
      name = "招标准备";
    } else if ("99".equals(businessStage)) {
      name = "合同准备";
    } 
    return name;
  }
  
  public String getBusinessOpportunityType(String businessOpportunityType) {
    String name = "";
    if ("1".equals(businessOpportunityType)) {
      name = "自有产品";
    } else if ("2".equals(businessOpportunityType)) {
      name = "外购产品";
    } else if ("3".equals(businessOpportunityType)) {
      name = "运维服务";
    } 
    return name;
  }
  
  public String getFundSource(String fundSource) {
    String name = "";
    if ("1".equals(fundSource)) {
      name = "用户自筹";
    } else if ("2".equals(fundSource)) {
      name = "财政拨款";
    } else if ("3".equals(fundSource)) {
      name = "第三方支付";
    } 
    return name;
  }
  
  public String getbusinessTypeName(String businessType) {
    String name = "";
    if ("1".equals(businessType)) {
      name = "卫生监督";
    } else if ("2".equals(businessType)) {
      name = "疾控业务";
    } else if ("3".equals(businessType)) {
      name = "疫情防控";
    } else if ("4".equals(businessType)) {
      name = "健康体检";
    } else if ("5".equals(businessType)) {
      name = "其他";
    } 
    return name;
  }
  
  public String getXmlxName(String xmlx) {
    String name = "";
    if ("1".equals(xmlx)) {
      name = "项目型";
    } else if ("2".equals(xmlx)) {
      name = "产品销售型";
    } else if ("3".equals(xmlx)) {
      name = "运维型";
    } 
    return name;
  }
  
  public String getXmjdName(String xmjd) {
    String name = "";
    if ("1".equals(xmjd)) {
      name = "售前";
    } else if ("2".equals(xmjd)) {
      name = "合同签订与执行";
    } else if ("3".equals(xmjd)) {
      name = "运维";
    } 
    return name;
  }
  
  public String getGzjlName(String jn) {
    String name = "";
    if ("1".equals(jn)) {
      name = "继续执行";
    } else if ("2".equals(jn)) {
      name = "终止项目";
    } else if ("3".equals(jn)) {
      name = "暂缓跟踪";
    } 
    return name;
  }
  
  public String getSqXmjdName(String sqXmjd) {
    String name = "";
    if ("1".equals(sqXmjd)) {
      name = "申请方案编写";
    } else if ("2".equals(sqXmjd)) {
      name = "方案上报_主管部门";
    } else if ("3".equals(sqXmjd)) {
      name = "方案上报_经信委";
    } else if ("4".equals(sqXmjd)) {
      name = "方案上报_财政审核";
    } else if ("5".equals(sqXmjd)) {
      name = "方案资金通过";
    } else if ("6".equals(sqXmjd)) {
      name = "招标文件编写";
    } else if ("7".equals(sqXmjd)) {
      name = "发布标讯";
    } else if ("8".equals(sqXmjd)) {
      name = "投标环节";
    } 
    return name;
  }
  
  public String getZyxName(String zyx) {
    String name = "";
    if ("1".equals(zyx)) {
      name = "非常重要";
    } else if ("2".equals(zyx)) {
      name = "重要";
    } else if ("3".equals(zyx)) {
      name = "一般";
    } 
    return name;
  }
  
  public String getBwdName(String bwd) {
    String name = "";
    if ("1".equals(bwd)) {
      name = "肯定性";
    } else if ("2".equals(bwd)) {
      name = "把握大";
    } else if ("3".equals(bwd)) {
      name = "不确定";
    } 
    return name;
  }
  
  public String getQdzxJdName(String jd) {
    String name = "";
    if ("1".equals(jd)) {
      name = "合同签订";
    } else if ("2".equals(jd)) {
      name = "完成首付款";
    } else if ("3".equals(jd)) {
      name = "初验付款";
    } else if ("4".equals(jd)) {
      name = "终验付款";
    } 
    return name;
  }
  
  public String getQdzxBzjztName(String bzjzt) {
    String name = "";
    if ("1".equals(bzjzt)) {
      name = "没有";
    } else if ("2".equals(bzjzt)) {
      name = "暂未支付";
    } else if ("3".equals(bzjzt)) {
      name = "已付";
    } else if ("4".equals(bzjzt)) {
      name = "已回";
    } 
    return name;
  }
  
  public String getQdzxZbtzsName(String zbtzs) {
    String name = "";
    if ("1".equals(zbtzs)) {
      name = "已领";
    } else if ("2".equals(zbtzs)) {
      name = "未领";
    } else if ("3".equals(zbtzs)) {
      name = "没有";
    } 
    return name;
  }
  
  public String getQdzxLybzjztName(String lybzjzt) {
    String name = "";
    if ("1".equals(lybzjzt)) {
      name = "没有";
    } else if ("2".equals(lybzjzt)) {
      name = "暂未支付";
    } else if ("3".equals(lybzjzt)) {
      name = "已付";
    } else if ("3".equals(lybzjzt)) {
      name = "已回";
    } 
    return name;
  }
  
  public String getSsqyName(String ssqy) {
    String name = "";
    if ("000000".equals(ssqy)) {
      name = "国家级";
    } else if ("110000".equals(ssqy)) {
      name = "北京市";
    } else if ("120000".equals(ssqy)) {
      name = "天津市";
    } else if ("130000".equals(ssqy)) {
      name = "河北省";
    } else if ("140000".equals(ssqy)) {
      name = "山西省";
    } else if ("150000".equals(ssqy)) {
      name = "内蒙古";
    } else if ("210000".equals(ssqy)) {
      name = "辽宁省";
    } else if ("220000".equals(ssqy)) {
      name = "吉林省";
    } else if ("230000".equals(ssqy)) {
      name = "黑龙江省";
    } else if ("310000".equals(ssqy)) {
      name = "上海市";
    } else if ("320000".equals(ssqy)) {
      name = "江苏省";
    } else if ("330000".equals(ssqy)) {
      name = "浙江省";
    } else if ("340000".equals(ssqy)) {
      name = "安徽省";
    } else if ("350000".equals(ssqy)) {
      name = "福建省";
    } else if ("360000".equals(ssqy)) {
      name = "江西省";
    } else if ("370000".equals(ssqy)) {
      name = "山东省";
    } else if ("410000".equals(ssqy)) {
      name = "河南省";
    } else if ("420000".equals(ssqy)) {
      name = "湖北省";
    } else if ("430000".equals(ssqy)) {
      name = "湖南省";
    } else if ("440000".equals(ssqy)) {
      name = "广东省";
    } else if ("450000".equals(ssqy)) {
      name = "广西壮族自治区";
    } else if ("460000".equals(ssqy)) {
      name = "海南省";
    } else if ("500000".equals(ssqy)) {
      name = "重庆市";
    } else if ("510000".equals(ssqy)) {
      name = "四川省";
    } else if ("520000".equals(ssqy)) {
      name = "贵州省";
    } else if ("530000".equals(ssqy)) {
      name = "云南省";
    } else if ("540000".equals(ssqy)) {
      name = "西藏自治区";
    } else if ("610000".equals(ssqy)) {
      name = "陕西省";
    } else if ("620000".equals(ssqy)) {
      name = "甘肃省";
    } else if ("630000".equals(ssqy)) {
      name = "青海省";
    } else if ("640000".equals(ssqy)) {
      name = "宁夏回族自治区";
    } else if ("650000".equals(ssqy)) {
      name = "新疆维吾尔自治区";
    } else if ("660000".equals(ssqy)) {
      name = "新疆生产建设兵团";
    } 
    return name;
  }
  
  public ActionForward getScxmInfoById(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    try {
      String id = request.getParameter("id");
      Session s = HibernateUtil.currentSession();
      Scxm scxm = (Scxm)s.get(Scxm.class, id);
      response.setContentType("text/html; charset=UTF-8");
      response.getWriter().print(JSON.toJSONString(scxm));
    } catch (IOException e) {
      throw new RuntimeException(e);
    } 
    return null;
  }
}
